/// <reference types="react" />
import type { CSSInterpolation, CSSObject } from '@ant-design/cssinjs';
import type { ComponentTokenMap, GlobalToken } from 'antd/es/theme/interface';
export type OverrideComponent = keyof ComponentTokenMap | (string & {});
export interface StyleInfo {
    hashId: string;
    prefixCls: string;
    rootPrefixCls: string;
    iconPrefixCls: string;
}
export type TokenWithCommonCls<T> = T & {
    /** Wrap component class with `.` prefix */
    componentCls: string;
    /** Origin prefix which do not have `.` prefix */
    prefixCls: string;
    /** Wrap icon class with `.` prefix */
    iconCls: string;
    /** Wrap ant prefixCls class with `.` prefix */
    antCls: string;
};
export type GenerateStyle<ComponentToken extends object = TokenWithCommonCls<GlobalToken>, ReturnType = CSSInterpolation> = (token: ComponentToken, options?: any) => ReturnType;
export declare const genCommonStyle: (token: any, componentPrefixCls: string) => CSSObject;
export type UseComponentStyleResult = [(node: React.ReactNode) => React.ReactElement, string];
export declare const genStyleHook: <ComponentName extends OverrideComponent>(component: ComponentName, styleFn: (token: TokenWithCommonCls<GlobalToken>, info: StyleInfo) => CSSInterpolation) => (prefixCls: string) => UseComponentStyleResult;
