import _extends from "@babel/runtime/helpers/extends";
import { useStyleRegister } from '@ant-design/cssinjs';
import { merge } from '@formily/shared';
import { useConfig, useToken } from './hooks';
export var genCommonStyle = function genCommonStyle(token, componentPrefixCls) {
  var _rootPrefixSelector, _ref;
  var fontFamily = token.fontFamily,
    fontSize = token.fontSize;
  var rootPrefixSelector = "[class^=\"" + componentPrefixCls + "\"], [class*=\" " + componentPrefixCls + "\"]";
  return _ref = {}, _ref[rootPrefixSelector] = (_rootPrefixSelector = {
    fontFamily: fontFamily,
    fontSize: fontSize,
    boxSizing: 'border-box',
    '&::before, &::after': {
      boxSizing: 'border-box'
    }
  }, _rootPrefixSelector[rootPrefixSelector] = {
    boxSizing: 'border-box',
    '&::before, &::after': {
      boxSizing: 'border-box'
    }
  }, _rootPrefixSelector), _ref;
};
export var genStyleHook = function genStyleHook(component, styleFn) {
  return function (prefixCls) {
    var _useToken = useToken(),
      theme = _useToken.theme,
      token = _useToken.token,
      hashId = _useToken.hashId;
    var _useConfig = useConfig(),
      getPrefixCls = _useConfig.getPrefixCls,
      iconPrefixCls = _useConfig.iconPrefixCls,
      csp = _useConfig.csp;
    var rootPrefixCls = getPrefixCls();
    return [useStyleRegister({
      nonce: csp === null || csp === void 0 ? void 0 : csp.nonce,
      theme: theme,
      token: token,
      hashId: hashId,
      path: ['lowcode-engine-skeleton', component, prefixCls, iconPrefixCls]
    }, function () {
      var componentCls = "." + prefixCls;
      var mergedToken = merge(token, _extends({}, token['skeleton'], {
        // Merge the antd form token
        componentCls: componentCls,
        prefixCls: prefixCls,
        iconCls: "." + iconPrefixCls,
        antCls: "." + rootPrefixCls
      }));
      var styleInterpolation = styleFn(mergedToken, {
        hashId: hashId,
        prefixCls: prefixCls,
        rootPrefixCls: rootPrefixCls,
        iconPrefixCls: iconPrefixCls
      });
      return [genCommonStyle(token, prefixCls), styleInterpolation];
    }), hashId];
  };
};