import _Button from "antd/es/button";
import _extends from "@babel/runtime/helpers/extends";
import React, { Fragment, useState, useLayoutEffect } from 'react';
import { createPortal } from 'react-dom';
import { observer, useField } from '@formily/react';
import { FormLayout } from '@formily/antd-v5';
import cls from 'classnames';
import useStyle from './style';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { createIcon } from '@gant-lowcode/lowcode-utils';
export var DrawerSetter = observer(function (props) {
  var field = useField();
  var _useState = useState(false),
    visible = _useState[0],
    setVisible = _useState[1];
  var _useState2 = useState(false),
    remove = _useState2[0],
    setRemove = _useState2[1];
  var _useState3 = useState(),
    root = _useState3[0],
    setRoot = _useState3[1];
  var prefixCls = usePrefixCls('drawer-setter', props);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var formWrapperCls = usePrefixCls('settings-form-wrapper');
  useLayoutEffect(function () {
    var wrapper = document.querySelector('.' + formWrapperCls);
    if (wrapper) {
      setRoot(wrapper);
    }
  }, []);
  var renderDrawer = function renderDrawer() {
    if (root && visible) {
      return /*#__PURE__*/createPortal(wrapSSR(/*#__PURE__*/React.createElement("div", {
        className: cls(prefixCls, hashId, 'animate__animated animate__slideInRight', {
          animate__slideOutRight: remove
        })
      }, /*#__PURE__*/React.createElement("div", {
        className: prefixCls + '-header',
        onClick: handleClose
      }, createIcon('houtui', {
        className: prefixCls + '-header-back'
      }), /*#__PURE__*/React.createElement("span", {
        className: prefixCls + '-header-text'
      }, props.text || field.title)), /*#__PURE__*/React.createElement("div", {
        className: prefixCls + '-body'
      }, /*#__PURE__*/React.createElement(FormLayout, {
        colon: false,
        labelWidth: 120,
        labelAlign: "left",
        wrapperAlign: "right",
        feedbackLayout: "none",
        tooltipLayout: "text"
      }, props.children)))), root);
    }
    return null;
  };
  var handleOpen = function handleOpen() {
    setVisible(true);
  };
  var handleClose = function handleClose() {
    setRemove(true);
    setTimeout(function () {
      setVisible(false);
      setRemove(false);
    }, 150);
  };
  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(_Button, _extends({
    block: true,
    onClick: handleOpen
  }, props.triggerProps), props.text || field.title), renderDrawer());
});