import _Modal from "antd/es/modal";
import _extends from "@babel/runtime/helpers/extends";
import _Tree from "antd/es/tree";
import _Row from "antd/es/row";
import _Input from "antd/es/input";
import _Col from "antd/es/col";
import _Switch from "antd/es/switch";
import _Segmented from "antd/es/segmented";
import _Form from "antd/es/form";
import React, { memo, useState } from 'react';
import { isObject } from 'lodash';
import { useControllableValue } from 'ahooks';
import cls from 'classnames';
import { createIcon } from '@gant-lowcode/lowcode-utils';
import { MonacoInput } from '../monaco-input';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { useStyle } from './style';
import { useSelected } from '../../../../hooks';
var paramTreeData = [{
  title: '项目 (Part)',
  key: 'part',
  children: [{
    title: '系统变量',
    key: 'system',
    children: [{
      title: 'currentUser (当前用户)',
      key: 'currentUser'
    }]
  }, {
    title: '状态变量',
    key: 'status',
    children: [{
      title: 'opType (模式)',
      key: 'opType'
    }]
  }, {
    title: '传参项',
    key: 'params',
    children: [{
      title: 'productId (产品)',
      key: 'productId'
    }]
  }, {
    title: '数据源',
    key: 'data',
    children: [{
      title: 'statusProvider',
      key: 'statusProvider'
    }]
  }, {
    title: '查询结果',
    key: 'result',
    children: [{
      title: 'formData',
      key: 'formData',
      children: [{
        title: 'product (产品)',
        key: 'product'
      }, {
        title: 'productNode (变更产品)',
        key: 'productNode'
      }]
    }]
  }]
}];
var options = [{
  value: 'expression',
  label: '表达式'
}, {
  value: 'boolean',
  label: '布尔值'
}, {
  value: 'ternary',
  label: '三元表达式'
}
// {
//   value: 'logic',
//   label: '逻辑判断',
// },
// {
//   value: 'custom',
//   label: '自定义函数',
// },
];
var ExpressionWidget = /*#__PURE__*/memo(function (_ref) {
  var value = _ref.value,
    onChange = _ref.onChange;
  console.log('LogicWidget--value', value);
  var _Form$useForm = _Form.useForm(),
    form = _Form$useForm[0];
  var onFormValueChange = function onFormValueChange(changedValues, values) {
    console.log('onFormValueChange--values', changedValues, values);
    onChange === null || onChange === void 0 ? void 0 : onChange(values);
  };
  return /*#__PURE__*/React.createElement(_Row, null, /*#__PURE__*/React.createElement(_Col, {
    span: 16
  }, /*#__PURE__*/React.createElement(_Segmented, {
    options: options,
    onChange: function onChange(value) {
      console.log(value); // string
    }
  }), /*#__PURE__*/React.createElement(_Form, {
    form: form,
    initialValues: value,
    onValuesChange: onFormValueChange,
    style: {
      maxWidth: 'none'
    }
  }, /*#__PURE__*/React.createElement(_Form.Item, {
    name: "value"
  }, /*#__PURE__*/React.createElement(MonacoInput, {
    height: 200,
    language: "javascript.expression",
    helpLink: false
  })), /*#__PURE__*/React.createElement(_Row, null, /*#__PURE__*/React.createElement(_Col, {
    flex: 1
  }, /*#__PURE__*/React.createElement(_Form.Item, {
    label: "\u4F5C\u4E3A\u9875\u9762\u53D8\u91CF",
    name: "isFixed"
  }, /*#__PURE__*/React.createElement(_Switch, null))), /*#__PURE__*/React.createElement(_Col, {
    flex: 1
  }, /*#__PURE__*/React.createElement(_Form.Item, {
    label: "\u53D8\u91CF\u540D",
    name: "variableName"
  }, /*#__PURE__*/React.createElement(_Input, {
    placeholder: "\u53D8\u91CF\u540D"
  })))))), /*#__PURE__*/React.createElement(_Col, null, /*#__PURE__*/React.createElement(_Tree, {
    treeData: paramTreeData,
    defaultExpandAll: true
  })));
});
export var ExpressionSetter = /*#__PURE__*/memo(function (props) {
  var className = props.className,
    style = props.style;
  var selected = useSelected();
  var prefixCls = usePrefixCls('expression-setter', props);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var _useControllableValue = useControllableValue(props, {
      defaultValue: {
        expression: ''
      }
    }),
    value = _useControllableValue[0],
    onChange = _useControllableValue[1];
  var _useState = useState(false),
    isModalOpen = _useState[0],
    setIsModalOpen = _useState[1];
  var showModal = function showModal() {
    setIsModalOpen(true);
  };
  var handleOk = function handleOk() {
    var _props$onChange;
    if (value.isFixed) {
      console.log('作为页面变量', selected);
      // selected.document.root?.getExtraProp('statements').add();
    }
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, _extends({
      type: 'JSExpression'
    }, value));
    setIsModalOpen(false);
  };
  var handleCancel = function handleCancel() {
    setIsModalOpen(false);
  };
  return wrapSSR(/*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls, hashId, className),
    style: style,
    onClick: showModal
  }, createIcon('fx', {
    className: cls(prefixCls + "-icon", {
      active: isObject(value) && value.type === 'JSExpression'
    })
  })), /*#__PURE__*/React.createElement(_Modal, {
    title: "\u903B\u8F91\u7F16\u8F91\u5668",
    open: isModalOpen,
    onCancel: handleCancel,
    onOk: handleOk,
    width: 900
  }, /*#__PURE__*/React.createElement(ExpressionWidget, _extends({}, props, {
    value: value,
    onChange: onChange
  })))));
});