import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "style", "children", "title", "defaultCollapsed", "collapse"],
  _excluded2 = ["className", "style", "children", "title", "defaultCollapsed", "collapse"];
import React, { useRef, useState } from 'react';
import { FormLayout } from '@formily/antd-v5';
import cls from 'classnames';
import useStyle from './style';
import { usePrefixCls } from '../../../../__builtins__/hooks';
import { createIcon } from '@gant-lowcode/lowcode-utils';
import { useField } from '@formily/react';
import { SlotProvider } from '../../context';
export var Card = function Card(_ref) {
  var className = _ref.className,
    style = _ref.style,
    children = _ref.children,
    title = _ref.title,
    _ref$defaultCollapsed = _ref.defaultCollapsed,
    defaultCollapsed = _ref$defaultCollapsed === void 0 ? true : _ref$defaultCollapsed,
    collapse = _ref.collapse,
    restProps = _objectWithoutPropertiesLoose(_ref, _excluded);
  var slotRef = useRef(null);
  var field = useField();
  var _useState = useState(defaultCollapsed),
    collapsed = _useState[0],
    setCollapsed = _useState[1];
  var prefixCls = usePrefixCls('settings-card', restProps);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var toggleCollapse = function toggleCollapse() {
    if (collapse) {
      setCollapsed(!collapsed);
    }
  };
  // 判断头部是否需要显示
  var headerTitle = field.title || title;
  return wrapSSR(/*#__PURE__*/React.createElement(SlotProvider, {
    value: {
      slotRef: slotRef
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls + "-layout", hashId, className, {
      active: collapsed,
      collapse: collapse
    }),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls + "-header", {
      hasTitle: !!headerTitle
    }),
    onClick: toggleCollapse
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-title"
  }, headerTitle), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-header-slot",
    ref: slotRef
  }), collapse && /*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls + "-collapse")
  }, createIcon('arrow-down', {
    size: 'xs',
    className: prefixCls + "-icon"
  }))), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-body"
  }, children)))));
};
export var FormCard = function FormCard(_ref2) {
  var className = _ref2.className,
    style = _ref2.style,
    children = _ref2.children,
    title = _ref2.title,
    _ref2$defaultCollapse = _ref2.defaultCollapsed,
    defaultCollapsed = _ref2$defaultCollapse === void 0 ? true : _ref2$defaultCollapse,
    collapse = _ref2.collapse,
    restProps = _objectWithoutPropertiesLoose(_ref2, _excluded2);
  return /*#__PURE__*/React.createElement(Card, {
    title: title,
    defaultCollapsed: defaultCollapsed,
    collapse: collapse,
    className: className,
    style: style
  }, /*#__PURE__*/React.createElement(FormLayout, restProps, children));
};