import React from 'react';
import { ReactFC } from '@formily/react';
export interface FormSwitchObjectProps {
    className?: string;
    style?: React.CSSProperties;
    children?: React.ReactNode;
    title?: string;
}
/**
 * Schema 驱动的开关对象字段组件
 *
 * 在 schema 中使用：
 * ```json
 * inputSearchProps: {
 *   type: 'object',
 *   'x-decorator': 'FormItem',
 *   'x-component': 'SwitchObjectField',
 *   'x-component-props': { title: '简易搜索' },
 *   properties: { ... 子字段配置 ... }
 * }
 * ```
 *
 * 当开关关闭时，字段值为 undefined；
 * 当开关开启时，字段值为包含子属性的对象。
 */
export declare const FormSwitchObject: ReactFC<FormSwitchObjectProps>;
