import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import { loader } from '@monaco-editor/react';
import chromeTheme from './themes/chrome';
import monokaiTheme from './themes/monokai';
import { format } from './format';
var initialized = false;
export var initMonaco = function initMonaco() {
  if (initialized) return;
  loader.init().then(function (monaco) {
    monaco.editor.defineTheme('monokai', monokaiTheme);
    monaco.editor.defineTheme('chrome-devtools', chromeTheme);
    monaco.languages.typescript.typescriptDefaults.setCompilerOptions({
      target: monaco.languages.typescript.ScriptTarget.Latest,
      allowNonTsExtensions: true,
      moduleResolution: monaco.languages.typescript.ModuleResolutionKind.NodeJs,
      module: monaco.languages.typescript.ModuleKind.CommonJS,
      noEmit: true,
      esModuleInterop: true,
      jsx: monaco.languages.typescript.JsxEmit.React,
      reactNamespace: 'React',
      allowJs: true
    });
    monaco.languages.typescript.typescriptDefaults.setDiagnosticsOptions({
      noSemanticValidation: false,
      noSyntaxValidation: true
    });
    monaco.languages.registerDocumentFormattingEditProvider('typescript', {
      provideDocumentFormattingEdits: function provideDocumentFormattingEdits(model) {
        return _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
          var _model$getDesignerLan;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return format(((_model$getDesignerLan = model['getDesignerLanguage']) === null || _model$getDesignerLan === void 0 ? void 0 : _model$getDesignerLan.call(model)) || 'typescript', model.getValue());
              case 2:
                _context.t0 = _context.sent;
                _context.t1 = model.getFullModelRange();
                _context.t2 = {
                  text: _context.t0,
                  range: _context.t1
                };
                return _context.abrupt("return", [_context.t2]);
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }))();
      }
    });
    initialized = true;
  });
};