import _Table from "antd/es/table";
import _extends from "@babel/runtime/helpers/extends";
import { observer, RecursionField, useFieldSchema } from '@formily/react';
import { isBool } from '@formily/shared';
import cls from 'classnames';
import React, { useRef, useState } from 'react';
import useStyle from './style';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { ArrayBase } from '@formily/antd-v5';
import { SubSlotProvider } from '../../../context';
import { ArrayTablePagination, indexKey, isColumnComponent, RowComp, useAddition, useArrayTableColumns, useArrayTableSources, WrapperComp } from '../common';
import { SideContent } from '../side-content';
export var AdvanceContent = observer(function (props) {
  var ref = useRef(null);
  var array = ArrayBase.useArray();
  var _useState = useState(null),
    subSlot = _useState[0],
    setSubSlot = _useState[1];
  var schema = useFieldSchema();
  schema['x-data'] = 'advance';
  var field = array.field;
  var prefixCls = usePrefixCls('advance-content');
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var sources = useArrayTableSources(field, schema, 'advance');
  var columns = useArrayTableColumns(dataSource, field, sources);
  var pagination = isBool(props.pagination) ? {} : props.pagination;
  var showPagination = isBool(props.pagination) ? props.pagination : true;
  var addition = useAddition(schema);
  var defaultRowKey = function defaultRowKey(record) {
    return record[indexKey];
  };
  console.log('---sources', sources, columns, dataSource);
  var children = wrapSSR(/*#__PURE__*/React.createElement("div", {
    className: cls(prefixCls, hashId)
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-left"
  }, /*#__PURE__*/React.createElement(ArrayTablePagination, _extends({}, pagination, {
    dataSource: dataSource,
    showPagination: showPagination
  }), function (dataSource, pager, _ref) {
    var startIndex = _ref.startIndex;
    return /*#__PURE__*/React.createElement("div", {
      ref: ref
    }, /*#__PURE__*/React.createElement(_Table, _extends({
      size: "small",
      bordered: true,
      rowKey: defaultRowKey
    }, props, {
      onChange: function onChange() {},
      pagination: false,
      columns: columns,
      dataSource: dataSource,
      components: {
        body: {
          wrapper: WrapperComp,
          row: RowComp
        }
      }
    })), /*#__PURE__*/React.createElement("div", {
      style: {
        marginTop: 5,
        marginBottom: 5
      }
    }, pager), sources.map(function (column, key) {
      //专门用来承接对Column的状态管理
      if (!isColumnComponent(column.schema)) return;
      return /*#__PURE__*/React.createElement(RecursionField, {
        name: column.name,
        schema: column.schema,
        onlyRenderSelf: true,
        key: key
      });
    }), addition);
  })), /*#__PURE__*/React.createElement("div", {
    className: prefixCls + "-right"
  }, /*#__PURE__*/React.createElement(SideContent, null))));
  return /*#__PURE__*/React.createElement(SubSlotProvider, {
    value: {
      setSubSlot: setSubSlot
    }
  }, children);
});