import _Button from "antd/es/button";
import _Space from "antd/es/space";
import _Pagination from "antd/es/pagination";
import _Select from "antd/es/select";
import _Badge from "antd/es/badge";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["tbodyRef"];
import { observer, RecursionField, useField } from '@formily/react';
import { isArr, isFn, isUndef } from '@formily/shared';
import cls from 'classnames';
import React, { createContext, forwardRef, Fragment, useContext, useEffect, useRef, useState } from 'react';
import useStyle from './style';
import { SortableContainer, SortableElement, SortableHandle, usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { ArrayBase } from '@formily/antd-v5';
import { useEditor } from '../../../../hooks';
import { EditOutlined, MenuOutlined } from '@ant-design/icons';
var SortableRow = SortableElement(function (props) {
  return /*#__PURE__*/React.createElement("tr", props);
});
var SortableBodyRaw = SortableContainer(function (_ref) {
  var tbodyRef = _ref.tbodyRef,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  return /*#__PURE__*/React.createElement("tbody", _extends({}, props, {
    ref: tbodyRef
  }));
});
var SortableBody = /*#__PURE__*/forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(SortableBodyRaw, _extends({}, props, {
    tbodyRef: ref
  }));
});
export var isIndexComponent = function isIndexComponent(schema) {
  var _schema$xComponent, _schema$xComponent$in;
  return ((_schema$xComponent = schema['x-component']) === null || _schema$xComponent === void 0 ? void 0 : (_schema$xComponent$in = _schema$xComponent.indexOf) === null || _schema$xComponent$in === void 0 ? void 0 : _schema$xComponent$in.call(_schema$xComponent, 'Index')) > -1;
};
export var isColumnComponent = function isColumnComponent(schema) {
  var _schema$xComponent2;
  return ((_schema$xComponent2 = schema['x-component']) === null || _schema$xComponent2 === void 0 ? void 0 : _schema$xComponent2.indexOf('Column')) > -1;
};
export var isSidePanelComponent = function isSidePanelComponent(schema) {
  var _schema$xComponent3;
  return ((_schema$xComponent3 = schema['x-component']) === null || _schema$xComponent3 === void 0 ? void 0 : _schema$xComponent3.indexOf('SidePanel')) > -1;
};
export var isSideAdditionComponent = function isSideAdditionComponent(schema) {
  var _schema$xComponent4;
  return ((_schema$xComponent4 = schema['x-component']) === null || _schema$xComponent4 === void 0 ? void 0 : _schema$xComponent4.indexOf('AddSidePanel')) > -1;
};
export var isOperationsComponent = function isOperationsComponent(schema) {
  var _schema$xComponent5;
  return ((_schema$xComponent5 = schema['x-component']) === null || _schema$xComponent5 === void 0 ? void 0 : _schema$xComponent5.indexOf('Operations')) > -1;
};
export var isAdditionComponent = function isAdditionComponent(schema) {
  var _schema$xComponent6;
  return ((_schema$xComponent6 = schema['x-component']) === null || _schema$xComponent6 === void 0 ? void 0 : _schema$xComponent6.indexOf('Addition')) > -1;
};
var isRemoveComponent = function isRemoveComponent(schema) {
  var _schema$xComponent7, _schema$xComponent7$i;
  return ((_schema$xComponent7 = schema['x-component']) === null || _schema$xComponent7 === void 0 ? void 0 : (_schema$xComponent7$i = _schema$xComponent7.indexOf) === null || _schema$xComponent7$i === void 0 ? void 0 : _schema$xComponent7$i.call(_schema$xComponent7, 'Remove')) > -1;
};
var isMoveUpComponent = function isMoveUpComponent(schema) {
  var _schema$xComponent8, _schema$xComponent8$i;
  return ((_schema$xComponent8 = schema['x-component']) === null || _schema$xComponent8 === void 0 ? void 0 : (_schema$xComponent8$i = _schema$xComponent8.indexOf) === null || _schema$xComponent8$i === void 0 ? void 0 : _schema$xComponent8$i.call(_schema$xComponent8, 'MoveUp')) > -1;
};
var isMoveDownComponent = function isMoveDownComponent(schema) {
  var _schema$xComponent9, _schema$xComponent9$i;
  return ((_schema$xComponent9 = schema['x-component']) === null || _schema$xComponent9 === void 0 ? void 0 : (_schema$xComponent9$i = _schema$xComponent9.indexOf) === null || _schema$xComponent9$i === void 0 ? void 0 : _schema$xComponent9$i.call(_schema$xComponent9, 'MoveDown')) > -1;
};
export var isOperationComponent = function isOperationComponent(schema) {
  return isAdditionComponent(schema) || isRemoveComponent(schema) || isMoveDownComponent(schema) || isMoveUpComponent(schema);
};
export var useArrayTableSources = function useArrayTableSources(arrayField, schema, mode) {
  if (mode === void 0) {
    mode = 'normal';
  }
  var _parseSources = function parseSources(schema) {
    if (isColumnComponent(schema) || isOperationsComponent(schema) || isAdditionComponent(schema)) {
      var _schema$xComponentP, _field$component;
      var xComponentProps = schema['x-component-props'] || {};
      if (!xComponentProps['dataIndex'] && !schema['name']) return [];
      var _display = 'visible';
      var name = ((_schema$xComponentP = schema['x-component-props']) === null || _schema$xComponentP === void 0 ? void 0 : _schema$xComponentP['dataIndex']) || schema['name'];
      var field = arrayField.query(arrayField.address.concat(name)).take();
      if (mode === 'normal') {
        _display = xComponentProps['env'] === mode ? 'visible' : 'hidden';
      }
      var columnProps = (field === null || field === void 0 ? void 0 : (_field$component = field.component) === null || _field$component === void 0 ? void 0 : _field$component[1]) || xComponentProps;
      var display = _display || (field === null || field === void 0 ? void 0 : field.display) || schema['x-display'];
      return [{
        name: name,
        display: display,
        field: field,
        schema: schema,
        columnProps: columnProps
      }];
    } else if (schema.properties) {
      return schema.reduceProperties(function (buf, schema) {
        return buf.concat(_parseSources(schema));
      }, []);
    }
    return [];
  };
  var parseArrayItems = function parseArrayItems(schema) {
    if (!schema) return [];
    var sources = [];
    var items = isArr(schema) ? schema : [schema];
    return items.reduce(function (columns, schema) {
      var item = _parseSources(schema);
      if (item) {
        return columns.concat(item);
      }
      return columns;
    }, sources);
  };
  if (!schema) throw new Error('can not found schema object');
  return parseArrayItems(schema.items);
};
export var LOWCODE_NODE_ID = '__lowcode_node_id__';
export var indexKey = '__DO_NOT_USE_THIS_PROPERTY_index__';
export var useArrayTableColumns = function useArrayTableColumns(dataSource, field, sources) {
  return sources.reduce(function (buf, _ref2, key) {
    var name = _ref2.name,
      columnProps = _ref2.columnProps,
      schema = _ref2.schema,
      display = _ref2.display;
    if (display !== 'visible') return buf;
    if (!isColumnComponent(schema)) return buf;
    return buf.concat(_extends({}, columnProps, {
      key: key,
      dataIndex: name,
      render: function render(value, record) {
        var index = record[indexKey];
        var children = /*#__PURE__*/React.createElement(ArrayBase.Item, {
          index: index,
          record: function record() {
            var _field$value;
            return field === null || field === void 0 ? void 0 : (_field$value = field.value) === null || _field$value === void 0 ? void 0 : _field$value[index];
          }
        }, /*#__PURE__*/React.createElement(RecursionField, {
          schema: schema,
          name: index,
          onlyRenderProperties: true
        }));
        return index > -1 ? children : null;
      }
    }));
  }, []);
};
export var useAddition = function useAddition(schema) {
  return schema.reduceProperties(function (addition, schema, key) {
    if (isAdditionComponent(schema)) {
      return /*#__PURE__*/React.createElement(RecursionField, {
        schema: schema,
        name: key
      });
    }
    return addition;
  }, null);
};
var schedulerRequest = {
  request: null
};
export var StatusSelect = observer(function (props) {
  var _props$options;
  var field = useField();
  var prefixCls = usePrefixCls('formily-array-table');
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var errors = field.errors;
  var parseIndex = function parseIndex(address) {
    var _address$slice$match;
    return Number(address === null || address === void 0 ? void 0 : (_address$slice$match = address.slice(address.indexOf(field.address.toString())).match(/(\d+)/)) === null || _address$slice$match === void 0 ? void 0 : _address$slice$match[1]);
  };
  var options = (_props$options = props.options) === null || _props$options === void 0 ? void 0 : _props$options.map(function (_ref3) {
    var label = _ref3.label,
      value = _ref3.value;
    var val = Number(value);
    var hasError = errors.some(function (_ref4) {
      var _props$options2;
      var address = _ref4.address;
      var currentIndex = parseIndex(address);
      var startIndex = props.pageSize ? (val - 1) * props.pageSize : 0;
      var endIndex = props.pageSize ? val * props.pageSize : ((_props$options2 = props.options) === null || _props$options2 === void 0 ? void 0 : _props$options2.length) || 0;
      return currentIndex >= startIndex && currentIndex <= endIndex;
    });
    return {
      label: hasError ? /*#__PURE__*/React.createElement(_Badge, {
        dot: true
      }, label) : label,
      value: value
    };
  });
  var width = String(options === null || options === void 0 ? void 0 : options.length).length * 15;
  return wrapSSR(/*#__PURE__*/React.createElement(_Select, {
    value: props.value,
    onChange: props.onChange,
    options: options,
    virtual: true,
    style: {
      width: width < 60 ? 60 : width
    },
    className: cls(prefixCls + "-status-select", hashId, {
      'has-error': errors === null || errors === void 0 ? void 0 : errors.length
    })
  }));
}, {
  scheduler: function scheduler(update) {
    clearTimeout(schedulerRequest.request);
    schedulerRequest.request = setTimeout(function () {
      update();
    }, 100);
  }
});
export var PaginationContext = /*#__PURE__*/createContext({});
export var usePagination = function usePagination() {
  return useContext(PaginationContext);
};
export var ArrayTablePagination = function ArrayTablePagination(props) {
  var _props$children;
  var _useState = useState(1),
    current = _useState[0],
    setCurrent = _useState[1];
  var prefixCls = usePrefixCls('formily-array-table');
  var _useStyle2 = useStyle(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  var _useState2 = useState(props.pageSize || 10),
    pageSize = _useState2[0],
    setPageSize = _useState2[1];
  var size = props.size || 'default';
  var dataSource = props.dataSource || [];
  var showPagination = props.showPagination;
  var startIndex = (current - 1) * pageSize;
  var endIndex = startIndex + pageSize - 1;
  var total = (dataSource === null || dataSource === void 0 ? void 0 : dataSource.length) || 0;
  var totalPage = Math.ceil(total / pageSize);
  var pages = Array.from(new Array(totalPage)).map(function (_, index) {
    var page = index + 1;
    return {
      label: page,
      value: page
    };
  });
  var handleChange = function handleChange(current) {
    setCurrent(current);
  };
  var handleSizeChange = function handleSizeChange(_, size) {
    setPageSize(size);
  };
  useEffect(function () {
    setPageSize(props.pageSize || 10);
  }, [props.pageSize]);
  useEffect(function () {
    if (totalPage > 0 && totalPage < current) {
      handleChange(totalPage);
    }
  }, [totalPage, current]);
  var renderPagination = function renderPagination() {
    if (!showPagination || totalPage < 1) return;
    return /*#__PURE__*/React.createElement("div", {
      className: cls(prefixCls + "-pagination", hashId)
    }, /*#__PURE__*/React.createElement(_Space, null, /*#__PURE__*/React.createElement(StatusSelect, {
      value: current,
      pageSize: pageSize,
      onChange: handleChange,
      options: pages,
      notFoundContent: false
    }), /*#__PURE__*/React.createElement(_Pagination, _extends({}, props, {
      pageSize: pageSize,
      current: current,
      total: dataSource.length,
      size: size,
      showSizeChanger: true,
      onShowSizeChange: handleSizeChange,
      onChange: handleChange
    }))));
  };
  return wrapSSR(/*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(PaginationContext.Provider, {
    value: {
      totalPage: totalPage,
      pageSize: pageSize,
      startIndex: startIndex,
      changePage: handleChange
    }
  }, (_props$children = props.children) === null || _props$children === void 0 ? void 0 : _props$children.call(props, showPagination ? dataSource === null || dataSource === void 0 ? void 0 : dataSource.slice(startIndex, endIndex + 1) : dataSource, renderPagination(), {
    startIndex: startIndex
  }))));
};
export var WrapperComp = function WrapperComp(props) {
  var ref = useRef(null);
  var field = useField();
  var prefixCls = usePrefixCls('formily-array-table');
  var _useContext = useContext(PaginationContext),
    startIndex = _useContext.startIndex;
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var addTdStyles = function addTdStyles(id) {
    var _ref$current;
    var node = (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.querySelector("." + prefixCls + "-row-" + id);
    var helper = document.body.querySelector("." + prefixCls + "-sort-helper");
    if (!helper) return;
    var tds = node === null || node === void 0 ? void 0 : node.querySelectorAll('td');
    if (!tds) return;
    requestAnimationFrame(function () {
      helper.querySelectorAll('td').forEach(function (td, index) {
        if (tds[index]) {
          td.style.width = getComputedStyle(tds[index]).width;
        }
      });
    });
  };
  return /*#__PURE__*/React.createElement(SortableBody, _extends({
    ref: ref
  }, props, {
    start: startIndex,
    list: dataSource.slice(),
    accessibility: {
      container: ref.current || undefined
    },
    onSortStart: function onSortStart(event) {
      addTdStyles(event.active.id);
    },
    onSortEnd: function onSortEnd(_ref5) {
      var oldIndex = _ref5.oldIndex,
        newIndex = _ref5.newIndex;
      field.move(oldIndex, newIndex);
    },
    className: cls(prefixCls + "-sort-helper", props.className)
  }));
};
export var RowComp = function RowComp(props) {
  var prefixCls = usePrefixCls('formily-array-table');
  var index = props['data-row-key'] || 0;
  return /*#__PURE__*/React.createElement(SortableRow, _extends({
    lockAxis: "y"
  }, props, {
    index: index,
    className: cls(props.className, prefixCls + "-row-" + (index + 1))
  }));
};
var InternalSortHandle = SortableHandle(function (props) {
  var prefixCls = usePrefixCls('formily-array-base');
  var _useStyle3 = useStyle(prefixCls),
    wrapSSR = _useStyle3[0],
    hashId = _useStyle3[1];
  return wrapSSR(/*#__PURE__*/React.createElement(MenuOutlined, _extends({}, props, {
    className: cls(prefixCls + "-sort-handle", hashId, props.className),
    style: _extends({}, props.style)
  })));
});
export var SortHandle = function SortHandle(props) {
  var _array$field;
  var array = ArrayBase.useArray();
  if (!array) return null;
  if (((_array$field = array.field) === null || _array$field === void 0 ? void 0 : _array$field.pattern) !== 'editable') return null;
  return /*#__PURE__*/React.createElement(InternalSortHandle, props);
};
export var isOpenComponent = function isOpenComponent(schema) {
  var _schema$xComponent10;
  return ((_schema$xComponent10 = schema['x-component']) === null || _schema$xComponent10 === void 0 ? void 0 : _schema$xComponent10.indexOf('Open')) > -1;
};
export var Navigation = /*#__PURE__*/forwardRef(function (props, ref) {
  var _array$field2;
  var record = ArrayBase.useRecord();
  var self = useField();
  var array = ArrayBase.useArray();
  var prefixCls = usePrefixCls('formily-array-base');
  var _useStyle4 = useStyle(prefixCls),
    wrapSSR = _useStyle4[0],
    hashId = _useStyle4[1];
  var editor = useEditor();
  if (!array) return null;
  if (array.schema['x-data'] === 'advance') return null;
  if (((_array$field2 = array.field) === null || _array$field2 === void 0 ? void 0 : _array$field2.pattern) !== 'editable') return null;
  return wrapSSR(/*#__PURE__*/React.createElement(_Button, _extends({
    type: "ghost"
  }, props, {
    style: _extends({
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: cls(prefixCls + "-navigation", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-navigation-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _editor$get, _editor$get$currentDo, _editor$get$currentDo2;
      if (self !== null && self !== void 0 && self.disabled || !record) return;
      var nodeId = record[LOWCODE_NODE_ID];
      console.log('----record', record, nodeId);
      (_editor$get = editor.get('project')) === null || _editor$get === void 0 ? void 0 : (_editor$get$currentDo = _editor$get.currentDocument) === null || _editor$get$currentDo === void 0 ? void 0 : (_editor$get$currentDo2 = _editor$get$currentDo.getNodeById(nodeId)) === null || _editor$get$currentDo2 === void 0 ? void 0 : _editor$get$currentDo2.select();
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
    },
    icon: isUndef(props.icon) ? /*#__PURE__*/React.createElement(EditOutlined, null) : props.icon
  }), props.title || self.title));
});
export var Column = function Column() {
  return /*#__PURE__*/React.createElement(Fragment, null);
};
export var SidePanel = function SidePanel(props) {
  return props.children;
};
export var Addition = function Addition(props) {
  var array = ArrayBase.useArray();
  var _usePagination = usePagination(),
    _usePagination$totalP = _usePagination.totalPage,
    totalPage = _usePagination$totalP === void 0 ? 0 : _usePagination$totalP,
    _usePagination$pageSi = _usePagination.pageSize,
    pageSize = _usePagination$pageSi === void 0 ? 10 : _usePagination$pageSi,
    changePage = _usePagination.changePage;
  return /*#__PURE__*/React.createElement(ArrayBase.Addition, _extends({}, props, {
    onClick: function onClick(e) {
      var _array$field3, _props$onClick;
      // 如果添加数据后将超过当前页，则自动切换到下一页
      var total = (array === null || array === void 0 ? void 0 : (_array$field3 = array.field) === null || _array$field3 === void 0 ? void 0 : _array$field3.value.length) || 0;
      if (total === totalPage * pageSize + 1 && isFn(changePage)) {
        changePage(totalPage + 1);
      }
      (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : _props$onClick.call(props, e);
    }
  }));
};
export var isActionComponent = function isActionComponent(schema) {
  var _schema$xComponent11;
  return ((_schema$xComponent11 = schema['x-component']) === null || _schema$xComponent11 === void 0 ? void 0 : _schema$xComponent11.indexOf('Action')) > -1;
};
export var Action = function Action(_ref6) {
  var children = _ref6.children;
  return children;
};
export var useAction = function useAction(schema) {
  return schema.reduceProperties(function (addition, schema, key) {
    if (isActionComponent(schema)) {
      return /*#__PURE__*/React.createElement(RecursionField, {
        schema: schema,
        name: key
      });
    }
    return addition;
  }, null);
};