import _Dropdown from "antd/es/dropdown";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _Button from "antd/es/button";
import _Collapse from "antd/es/collapse";
import _extends from "@babel/runtime/helpers/extends";
import _Badge from "antd/es/badge";
import _Card from "antd/es/card";
import _Empty from "antd/es/empty";
var _excluded = ["onClick"];
import { observer, RecursionField, useField, useFieldSchema } from '@formily/react';
import { isUndef, toArr } from '@formily/shared';
import cls from 'classnames';
import React, { forwardRef, useEffect, useState } from 'react';
import useStyle from './style';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { ArrayBase } from '@formily/antd-v5';
import { isIndexComponent, isSidePanelComponent } from '../common';
import { get, set } from 'lodash';
import { DeleteOutlined } from '@ant-design/icons';
var range = function range(count) {
  return Array.from({
    length: count
  }).map(function (_, i) {
    return i;
  });
};
var takeDefaultActiveKeys = function takeDefaultActiveKeys(dataSourceLength, defaultOpenPanelCount) {
  if (dataSourceLength < defaultOpenPanelCount) return range(dataSourceLength);
  return range(defaultOpenPanelCount);
};
var insertActiveKeys = function insertActiveKeys(activeKeys, index) {
  if (activeKeys.length <= index) return activeKeys.concat(index);
  return activeKeys.reduce(function (buf, key) {
    if (key < index) return buf.concat(key);
    if (key === index) return buf.concat([key, key + 1]);
    return buf.concat(key + 1);
  }, []);
};
export var SideContent = observer(function (props) {
  var _props$defaultOpenPan;
  var array = ArrayBase.useArray();
  var schema = useFieldSchema();
  var field = array.field;
  var prefixCls = usePrefixCls('side-content', props);
  var _useStyle = useStyle(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var _useState = useState(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan !== void 0 ? _props$defaultOpenPan : Infinity)),
    activeKeys = _useState[0],
    setActiveKeys = _useState[1];
  useEffect(function () {
    if (!field.modified && dataSource.length) {
      var _props$defaultOpenPan2;
      setActiveKeys(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan2 = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan2 !== void 0 ? _props$defaultOpenPan2 : Infinity));
    }
  }, [dataSource.length, field]);
  if (!schema) throw new Error('can not found schema object');
  var renderEmpty = function renderEmpty() {
    if (dataSource.filter(function (item) {
      return get(item, 'decorator-props.options.rules');
    }).length) return;
    return /*#__PURE__*/React.createElement(_Card, {
      className: cls(prefixCls + "-item", hashId, props.className)
    }, /*#__PURE__*/React.createElement(_Empty, null));
  };
  var renderItems = function renderItems() {
    if (dataSource.filter(function (item) {
      return get(item, 'decorator-props.options.rules');
    }).length === 0) {
      return null;
    }
    return /*#__PURE__*/React.createElement(_Collapse, _extends({}, props, {
      activeKey: activeKeys,
      onChange: function onChange(keys) {
        setActiveKeys(toArr(keys).map(Number));
      },
      className: cls(prefixCls + "-item", hashId, props.className)
    }), dataSource.map(function (item, index) {
      if (!get(item, 'decorator-props.options.rules')) return null;
      var items = Array.isArray(schema.items) ? schema.items[index] || schema.items[0] : schema.items;
      if (!items) return null;
      var header = function header() {
        var header = get(item, 'decorator-props.title');
        var path = field.address.concat(index);
        var errors = field.form.queryFeedbacks({
          type: 'error',
          address: path + ".**"
        });
        return /*#__PURE__*/React.createElement(ArrayBase.Item, {
          index: index,
          record: function record() {
            var _field$value;
            return (_field$value = field.value) === null || _field$value === void 0 ? void 0 : _field$value[index];
          }
        }, /*#__PURE__*/React.createElement(RecursionField, {
          schema: items,
          name: index,
          filterProperties: function filterProperties(schema) {
            if (!isIndexComponent(schema)) return false;
            return true;
          },
          onlyRenderProperties: true
        }), errors.length ? /*#__PURE__*/React.createElement(_Badge, {
          size: "small",
          className: "errors-badge",
          count: errors.length
        }, header) : header);
      };
      var extra = /*#__PURE__*/React.createElement(ArrayBase.Item, {
        index: index,
        record: item
      }, /*#__PURE__*/React.createElement(Remove, null));
      var content = /*#__PURE__*/React.createElement(RecursionField, {
        schema: items,
        name: index,
        filterProperties: function filterProperties(schema) {
          if (isSidePanelComponent(schema)) return true;
          return false;
        }
      });
      return /*#__PURE__*/React.createElement(_Collapse.Panel, _extends({}, props, {
        forceRender: true,
        key: index,
        header: header(),
        extra: extra
      }), /*#__PURE__*/React.createElement(ArrayBase.Item, {
        index: index,
        key: index,
        record: item
      }, content));
    }));
  };
  return wrapSSR(/*#__PURE__*/React.createElement(_Card, {
    title: "\u6821\u9A8C\u89C4\u5219"
  }, /*#__PURE__*/React.createElement(ArrayBase, {
    onAdd: function onAdd(index) {
      setActiveKeys(insertActiveKeys(activeKeys, index));
    }
  }, renderEmpty(), renderItems(), /*#__PURE__*/React.createElement(Addition, null))));
});
var Remove = /*#__PURE__*/forwardRef(function (props, ref) {
  var _array$field;
  var index = ArrayBase.useIndex(props.index);
  var self = useField();
  var array = ArrayBase.useArray();
  var value = array.field.value || [];
  var prefixCls = usePrefixCls('formily-array-base');
  var _useStyle2 = useStyle(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  if (!array) return null;
  if (((_array$field = array.field) === null || _array$field === void 0 ? void 0 : _array$field.pattern) !== 'editable') return null;
  return wrapSSR(/*#__PURE__*/React.createElement(_Button, _extends({
    type: "ghost"
  }, props, {
    style: _extends({
      padding: '0 0 0 6px',
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: cls(prefixCls + "-remove", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-remove-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _array$props, _array$props$onRemove;
      if (self !== null && self !== void 0 && self.disabled) return;
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
      set(value, index + ".decorator-props.options.rules", undefined);
      (_array$props = array.props) === null || _array$props === void 0 ? void 0 : (_array$props$onRemove = _array$props.onRemove) === null || _array$props$onRemove === void 0 ? void 0 : _array$props$onRemove.call(_array$props, index);
    },
    icon: isUndef(props.icon) ? /*#__PURE__*/React.createElement(DeleteOutlined, null) : props.icon
  }), props.title || self.title));
});
export var Addition = observer(function (_ref) {
  var onClick = _ref.onClick,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var array = ArrayBase.useArray();
  var value = array.field.value || [];
  var dataSource = value.filter(function (item) {
    return item && get(item, 'decorator-props.title') && get(item, 'decorator-props.fieldName');
  });
  var rules = value.filter(function (item) {
    return item && get(item, 'decorator-props.options.rules');
  });
  var len = rules.length;
  var items = value.reduce(function (options, item, index) {
    var label = get(item, 'decorator-props.title');
    if (item && get(item, 'decorator-props.title') && get(item, 'decorator-props.fieldName') && !rules.some(function (item) {
      return get(item, 'decorator-props.title') === label;
    })) {
      options.push({
        label: label,
        key: index
      });
    }
    return options;
  }, []);
  if (dataSource.length === len) return null;
  var onDropdownClick = function onDropdownClick(menuInfo) {
    var key = menuInfo.key;
    set(value, key + ".decorator-props.options.rules", []);
    if (onClick) {
      onClick(menuInfo);
    }
  };
  return /*#__PURE__*/React.createElement(_Dropdown, {
    menu: {
      items: items,
      onClick: onDropdownClick
    },
    trigger: ['click']
  }, /*#__PURE__*/React.createElement(_Button, _extends({
    color: "primary",
    variant: "filled"
  }, props), "\u6DFB\u52A0\u9A8C\u8BC1\u5B57\u6BB5"));
});