import _Button from "antd/es/button";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "style", "value", "onChange", "exclude", "include"];
import React, { useEffect, useState, useRef, memo } from 'react';
import cls from 'classnames';
import { usePrefixCls } from '@formily/antd-v5/lib/__builtins__';
import { createIcon } from '@gant-lowcode/lowcode-utils';
import { useStyle } from './style';
var isValid = function isValid(val) {
  return val !== undefined && val !== null;
};
var getEventValue = function getEventValue(event) {
  if (event !== null && event !== void 0 && event.target) {
    if (isValid(event.target.value)) return event.target.value;
    if (isValid(event.target.checked)) return event.target.checked;
    return;
  }
  return event;
};
var createTypes = function createTypes(types, exclude, include) {
  return types.filter(function (_ref) {
    var type = _ref.type;
    if (Array.isArray(include) && include.length) {
      return include.includes(type);
    }
    if (Array.isArray(exclude) && exclude.length) {
      return !exclude.includes(type);
    }
    return true;
  });
};
export function createPolyInput(polyTypes) {
  if (polyTypes === void 0) {
    polyTypes = [];
  }
  return /*#__PURE__*/memo(function (_ref2) {
    var _types$;
    var className = _ref2.className,
      style = _ref2.style,
      value = _ref2.value,
      _onChange = _ref2.onChange,
      exclude = _ref2.exclude,
      include = _ref2.include,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);
    var prefixCls = usePrefixCls('poly-input', props);
    var _useStyle = useStyle(prefixCls),
      wrapSSR = _useStyle[0],
      hashId = _useStyle[1];
    var types = createTypes(polyTypes, exclude, include);
    var _useState = useState((_types$ = types[0]) === null || _types$ === void 0 ? void 0 : _types$.type),
      current = _useState[0],
      setCurrent = _useState[1];
    var type = types === null || types === void 0 ? void 0 : types.find(function (_ref3) {
      var type = _ref3.type;
      return type === current;
    });
    var component = type === null || type === void 0 ? void 0 : type.component;
    var typesValue = useRef({});
    useEffect(function () {
      types === null || types === void 0 ? void 0 : types.forEach(function (_ref4) {
        var checker = _ref4.checker,
          type = _ref4.type;
        if (checker(value)) {
          setCurrent(type);
        }
      });
    }, [value]);
    var getNextType = function getNextType() {
      var currentIndex = types === null || types === void 0 ? void 0 : types.findIndex(function (_ref5) {
        var type = _ref5.type;
        return type === current;
      });
      var nextIndex = currentIndex + 1 > (types === null || types === void 0 ? void 0 : types.length) - 1 ? 0 : currentIndex + 1;
      return types[nextIndex];
    };
    var transformOnChangeValue = function transformOnChangeValue(value, type) {
      return type !== null && type !== void 0 && type.toChangeValue ? type === null || type === void 0 ? void 0 : type.toChangeValue(value) : value;
    };
    if (types.length === 2 && types.some(function (_ref6) {
      var type = _ref6.type;
      return type === 'EXPRESSION';
    })) {
      return wrapSSR(/*#__PURE__*/React.createElement("div", {
        className: cls(prefixCls, hashId, className),
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: prefixCls + "-mixed"
      }, types.map(function (type) {
        return /*#__PURE__*/React.createElement(type === null || type === void 0 ? void 0 : type.component, _extends({}, props, {
          value: type !== null && type !== void 0 && type.toInputValue ? type === null || type === void 0 ? void 0 : type.toInputValue(value) : value,
          onChange: function onChange(event) {
            var value = getEventValue(event);
            typesValue.current[type === null || type === void 0 ? void 0 : type.type] = value;
            _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(value, type));
          }
        }));
      }))));
    }
    var controller = /*#__PURE__*/React.createElement(_Button, {
      className: prefixCls + "-controller",
      style: {
        width: !component ? '100%' : 'auto'
      },
      block: true,
      onClick: function onClick() {
        var nextType = getNextType();
        if (nextType === type) return;
        setCurrent(nextType === null || nextType === void 0 ? void 0 : nextType.type);
        _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(typesValue.current[nextType === null || nextType === void 0 ? void 0 : nextType.type], nextType));
      }
    }, type !== null && type !== void 0 && type.icon ? createIcon(type.icon, props) : (type === null || type === void 0 ? void 0 : type.title) || (type === null || type === void 0 ? void 0 : type.type));
    return wrapSSR(/*#__PURE__*/React.createElement("div", {
      className: cls(prefixCls, hashId, className),
      style: style
    }, component && /*#__PURE__*/React.createElement("div", {
      className: prefixCls + "-content"
    }, /*#__PURE__*/React.createElement(component, _extends({}, props, {
      value: type !== null && type !== void 0 && type.toInputValue ? type === null || type === void 0 ? void 0 : type.toInputValue(value) : value,
      onChange: function onChange(event) {
        var value = getEventValue(event);
        typesValue.current[type === null || type === void 0 ? void 0 : type.type] = value;
        _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(value, type));
      }
    }))), controller));
  });
}