import React, { useMemo } from 'react';
import { createForm, onFormValuesChange } from '@formily/core';
import cls from 'classnames';
import { debounce } from 'lodash';
import { Form } from '@formily/antd-v5';
import { observer } from '@gant-lowcode/lowcode-editor-core';
var schema = {
  type: 'object',
  properties: {
    layout: {
      type: 'void',
      'x-component': 'FormCard',
      'x-component-props': {
        labelAlign: 'left',
        labelCol: 6,
        feedbackLayout: 'terse',
        colon: false
      },
      properties: {
        title: {
          type: 'string',
          title: '物料名称',
          'x-decorator': 'FormItem',
          'x-component': 'Input'
        }
      }
    }
  }
};
export var RenameNodeForm = observer(function (_ref) {
  var className = _ref.className,
    style = _ref.style,
    main = _ref.main;
  var form = useMemo(function () {
    var values = {
      title: main.settings.titleLabel
    };
    return createForm({
      values: values,
      effects: function effects() {
        onFormValuesChange(debounce(function (form) {
          var values = form.values;
          main.settings.setTitleLabel(values.title);
        }, 100));
      }
    });
  }, [main]);
  var SchemaField = main.SchemaField;
  return /*#__PURE__*/React.createElement(Form, {
    className: cls('lc-node-rename-form', className),
    form: form,
    style: style
  }, /*#__PURE__*/React.createElement(SchemaField, {
    schema: schema
  }));
});