import _AutoComplete from "antd/es/auto-complete";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["value", "options"];
import { connect, mapProps, mapReadPretty } from '@formily/react';
import { useState } from 'react';
import cls from 'classnames';
import { LoadingOutlined } from '@ant-design/icons';
import { PreviewText } from '@formily/antd-v5';
var _SelectInput = function _SelectInput(_ref) {
  var value = _ref.value,
    options = _ref.options,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var _useState = useState(options),
    _options = _useState[0],
    setOptions = _useState[1];
  var getPanelValue = function getPanelValue(searchText) {
    return !searchText ? [] : [{
      value: searchText,
      label: searchText
    }];
  };
  var filterOption = function filterOption(inputValue, option) {
    return ((option === null || option === void 0 ? void 0 : option.value) + '').toLowerCase().includes(inputValue.toLowerCase());
  };
  return /*#__PURE__*/React.createElement(_AutoComplete, _extends({
    options: _options,
    value: value,
    onSearch: function onSearch(text) {
      return setOptions(getPanelValue(text));
    },
    allowClear: true,
    filterOption: filterOption,
    style: {
      width: '100%'
    }
  }, props));
};

/**
 * 输入选择组合组件
 */
export var SelectInput = connect(_SelectInput, mapProps({
  dataSource: 'options',
  loading: true
}, function (props, field) {
  return _extends({}, props, {
    className: cls(props.className, 'gant-formily-input-select'),
    optionFontSize: 12,
    suffixIcon: field !== null && field !== void 0 && field['loading'] || field !== null && field !== void 0 && field['validating'] ? /*#__PURE__*/React.createElement(LoadingOutlined, null) : props.suffixIcon
  });
}), mapReadPretty(PreviewText.Select));