import _InputNumber from "antd/es/input-number";
import _Switch from "antd/es/switch";
import _Checkbox from "antd/es/checkbox";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _Input from "antd/es/input";
var _excluded = ["className", "mode"];
import React from 'react';
import cls from 'classnames';
import { createPolyInput } from '../poly-input';
import { ExpressionSetter } from '../expression-setter';
var STARTTAG_REX = /<([-A-Za-z0-9_]+)((?:\s+[a-zA-Z_:][-a-zA-Z0-9_:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)>/;
var isNumber = function isNumber(value) {
  return typeof value === 'number';
};
var isBoolean = function isBoolean(value) {
  return typeof value === 'boolean';
};
var isExpression = function isExpression(value) {
  return typeof value === 'object' && value.type === 'JSExpression';
};
var isRichText = function isRichText(value) {
  return typeof value === 'string' && STARTTAG_REX.test(value);
};
var isNormalText = function isNormalText(value) {
  return typeof value === 'string' && !isExpression(value) && !isRichText(value);
};
var takeNumber = function takeNumber(value) {
  var num = String(value).replace(/[^\d\.]+/, '');
  if (num === '') return;
  return Number(num);
};
export var ValueInput = createPolyInput([{
  type: 'TEXT',
  icon: 'text',
  component: _Input,
  checker: isNormalText
}, {
  type: 'BOOLEAN',
  icon: 'boolean',
  component: function component(_ref) {
    var className = _ref.className,
      mode = _ref.mode,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);
    if (mode === 'checkbox') {
      return /*#__PURE__*/React.createElement(_Checkbox, _extends({}, props, {
        className: cls(className, 'value-input-switch')
      }));
    }
    return /*#__PURE__*/React.createElement(_Switch, _extends({}, props, {
      className: cls(className, 'value-input-switch')
    }));
  },
  checker: isBoolean,
  toInputValue: function toInputValue(value) {
    return !!value;
  },
  toChangeValue: function toChangeValue(value) {
    return !!value;
  }
}, {
  type: 'NUMBER',
  icon: 'number',
  component: _InputNumber,
  checker: isNumber,
  toInputValue: takeNumber,
  toChangeValue: takeNumber
}, {
  type: 'EXPRESSION',
  icon: 'expression',
  component: ExpressionSetter,
  // component: (props: any) => {
  //   return (
  //     <Popover
  //       rootClassName="monaco-input-popover"
  //       content={
  //         <div
  //           style={{
  //             width: 400,
  //             height: 200,
  //             marginLeft: -12,
  //             marginRight: -12,
  //             marginBottom: -4,
  //           }}
  //         >
  //           <MonacoInput {...props} language="javascript.expression" />
  //         </div>
  //       }
  //       trigger="click"
  //     >
  //       <div>fx</div>
  //     </Popover>
  //   );
  // },
  checker: isExpression
  // toInputValue: (value) => {
  //   if (!value || value === '{{}}') return;
  //   const matched = String(value).match(EXPRESSION_REX);
  //   return matched?.[1] || value || '';
  // },
  // toChangeValue: (value) => {
  //   if (!value || value === '{{}}') return;
  //   const matched = String(value).match(EXPRESSION_REX);
  //   return `{{${matched?.[1] || value || ''}}}`;
  // },
}]);