import React, { useEffect, useRef } from 'react';
import classNames from 'classnames';
import { IconArrow } from '../../icons/arrow';
import { IconExit } from '../../icons/exit';
import { isTitleConfig } from '@gant-lowcode/lowcode-utils';
var Stage = function Stage(_ref) {
  var stage = _ref.stage,
    _ref$current = _ref.current,
    current = _ref$current === void 0 ? false : _ref$current,
    direction = _ref.direction;
  var additionClassNameRef = useRef(null);
  var shellRef = useRef(null);
  useEffect(function () {
    var timer = null;
    if (additionClassNameRef.current && shellRef.current) {
      timer = window.setTimeout(function () {
        var elem = shellRef.current;
        if (elem) {
          current ? elem.classList.remove(additionClassNameRef.current) : elem.classList.add(additionClassNameRef.current);
          additionClassNameRef.current = null;
        }
      }, 15);
    }
    return function () {
      return window.clearTimeout(timer);
    };
  }, [current, direction]);
  var _ref2 = stage,
    title = _ref2.title;
  var newTitle = isTitleConfig(title) ? title.label : title;
  var content = stage === null || stage === void 0 ? void 0 : stage.getContent();
  if (current && direction) {
    additionClassNameRef.current = "skeleton-stagebox-stagein-" + direction;
  } else if (direction) {
    additionClassNameRef.current = "skeleton-stagebox-stageout-" + direction;
  }
  var className = classNames('skeleton-stagebox-stage', {
    'skeleton-stagebox-refer': !current
  }, additionClassNameRef.current);
  var stageBacker = (stage === null || stage === void 0 ? void 0 : stage.hasBack()) && /*#__PURE__*/React.createElement("div", {
    className: "skeleton-stagebox-stagebacker"
  }, /*#__PURE__*/React.createElement(IconArrow, {
    className: "skeleton-stagebox-stage-arrow",
    size: "medium",
    "data-stage-target": "stageback"
  }), /*#__PURE__*/React.createElement("span", {
    className: "skeleton-stagebox-stage-title"
  }, newTitle), /*#__PURE__*/React.createElement(IconExit, {
    className: "skeleton-stagebox-stage-exit",
    size: "medium",
    "data-stage-target": "stageexit"
  }));
  return /*#__PURE__*/React.createElement("div", {
    ref: shellRef,
    className: className
  }, stageBacker, /*#__PURE__*/React.createElement("div", {
    className: "skeleton-stagebox-stage-content"
  }, content));
};
export default Stage;