import { Fragment } from 'react';
import classNames from 'classnames';
import { observer } from '@gant-lowcode/lowcode-editor-core';
var SubTopArea = observer(function (_ref) {
  var area = _ref.area,
    itemClassName = _ref.itemClassName;
  if (area.isEmpty()) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classNames('lc-workspace-sub-top-area lc-sub-top-area engine-actionpane', {
      'lc-area-visible': area.visible
    })
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area,
    itemClassName: itemClassName
  }));
});
export default SubTopArea;
var Contents = observer(function (_ref2) {
  var area = _ref2.area,
    itemClassName = _ref2.itemClassName;
  var left = [];
  var center = [];
  var right = [];
  area.container.items.slice().sort(function (a, b) {
    var _a$config, _b$config;
    var index1 = ((_a$config = a.config) === null || _a$config === void 0 ? void 0 : _a$config.index) || 0;
    var index2 = ((_b$config = b.config) === null || _b$config === void 0 ? void 0 : _b$config.index) || 0;
    return index1 === index2 ? 0 : index1 > index2 ? 1 : -1;
  }).forEach(function (item) {
    var content = /*#__PURE__*/React.createElement("div", {
      className: itemClassName || '',
      key: "top-area-" + item.name
    }, item.content);
    if (item.align === 'center') {
      center.push(content);
    } else if (item.align === 'left') {
      left.push(content);
    } else {
      right.push(content);
    }
  });
  var children = [];
  if (left.length) {
    children.push(/*#__PURE__*/React.createElement("div", {
      key: "left",
      className: "lc-workspace-sub-top-area-left lc-sub-top-area-left"
    }, left));
  }
  if (center.length) {
    children.push(/*#__PURE__*/React.createElement("div", {
      key: "center",
      className: "lc-workspace-sub-top-area-center lc-sub-top-area-center"
    }, center));
  }
  if (right.length) {
    children.push(/*#__PURE__*/React.createElement("div", {
      key: "right",
      className: "lc-workspace-sub-top-area-right lc-sub-top-area-right"
    }, right));
  }
  return /*#__PURE__*/React.createElement(Fragment, null, children);
});