import { Fragment } from 'react';
import classNames from 'classnames';
import { observer } from '@gant-lowcode/lowcode-editor-core';
var Toolbar = observer(function (_ref) {
  var area = _ref.area;
  if (area.isEmpty()) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classNames('lc-toolbar', {
      'lc-area-visible': area.visible
    })
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area
  }));
});
export default Toolbar;
var Contents = observer(function (_ref2) {
  var area = _ref2.area;
  var left = [];
  var center = [];
  var right = [];
  area.container.items.forEach(function (item) {
    if (item.align === 'center') {
      center.push(item.content);
    } else if (item.align === 'right') {
      right.push(item.content);
    } else {
      left.push(item.content);
    }
  });
  return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-left"
  }, left), /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-center"
  }, center), /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-right"
  }, right));
});