"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.genStyleHook = exports.genCommonStyle = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _cssinjs = require("@ant-design/cssinjs");
var _shared = require("@formily/shared");
var _hooks = require("./hooks");
var genCommonStyle = exports.genCommonStyle = function genCommonStyle(token, componentPrefixCls) {
  var _rootPrefixSelector, _ref;
  var fontFamily = token.fontFamily,
    fontSize = token.fontSize;
  var rootPrefixSelector = "[class^=\"" + componentPrefixCls + "\"], [class*=\" " + componentPrefixCls + "\"]";
  return _ref = {}, _ref[rootPrefixSelector] = (_rootPrefixSelector = {
    fontFamily: fontFamily,
    fontSize: fontSize,
    boxSizing: 'border-box',
    '&::before, &::after': {
      boxSizing: 'border-box'
    }
  }, _rootPrefixSelector[rootPrefixSelector] = {
    boxSizing: 'border-box',
    '&::before, &::after': {
      boxSizing: 'border-box'
    }
  }, _rootPrefixSelector), _ref;
};
var genStyleHook = exports.genStyleHook = function genStyleHook(component, styleFn) {
  return function (prefixCls) {
    var _useToken = (0, _hooks.useToken)(),
      theme = _useToken.theme,
      token = _useToken.token,
      hashId = _useToken.hashId;
    var _useConfig = (0, _hooks.useConfig)(),
      getPrefixCls = _useConfig.getPrefixCls,
      iconPrefixCls = _useConfig.iconPrefixCls,
      csp = _useConfig.csp;
    var rootPrefixCls = getPrefixCls();
    return [(0, _cssinjs.useStyleRegister)({
      nonce: csp === null || csp === void 0 ? void 0 : csp.nonce,
      theme: theme,
      token: token,
      hashId: hashId,
      path: ['lowcode-engine-skeleton', component, prefixCls, iconPrefixCls]
    }, function () {
      var componentCls = "." + prefixCls;
      var mergedToken = (0, _shared.merge)(token, (0, _extends2["default"])({}, token['skeleton'], {
        // Merge the antd form token
        componentCls: componentCls,
        prefixCls: prefixCls,
        iconCls: "." + iconPrefixCls,
        antCls: "." + rootPrefixCls
      }));
      var styleInterpolation = styleFn(mergedToken, {
        hashId: hashId,
        prefixCls: prefixCls,
        rootPrefixCls: rootPrefixCls,
        iconPrefixCls: iconPrefixCls
      });
      return [genCommonStyle(token, prefixCls), styleInterpolation];
    }), hashId];
  };
};