"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.AdvanceContent = void 0;
var _space = _interopRequireDefault(require("antd/lib/space"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _empty = _interopRequireDefault(require("antd/lib/empty"));
var _react = require("@formily/react");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _context = require("../../../context");
var _common = require("../common");
var _sideContent = require("../side-content");
var _hooks = require("../hooks");
var _hooks2 = require("../../../../../hooks");
var _settingsPrimaryPane = require("../../../settings-primary-pane");
var _excluded = ["className", "rowSelectionOptions"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var ChildrenSettings = function ChildrenSettings(_ref) {
  var childrenNode = _ref.childrenNode;
  if (!childrenNode) return /*#__PURE__*/_react2["default"].createElement(_empty["default"], {
    description: "\u8BF7\u5148\u5728\u8868\u683C\u9009\u62E9\u7F16\u8F91\u9879"
  });
  var settings = childrenNode.settingEntry;
  return /*#__PURE__*/_react2["default"].createElement(_settingsPrimaryPane.Settings, {
    settings: settings
  });
};
var AdvanceContent = exports.AdvanceContent = (0, _react.observer)(function (_ref2) {
  var className = _ref2.className,
    rowSelectionOptions = _ref2.rowSelectionOptions,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
  var selected = (0, _hooks2.useSelected)();
  var main = (0, _hooks2.useSettingsMain)();
  var slotRef = (0, _react2.useRef)(null);
  var valueMode = (0, _common.useValueMode)();
  var array = _antdV.ArrayBase.useArray();
  var field = array.field;
  var schema = (0, _react.useFieldSchema)();
  var _useCommonUI = (0, _hooks2.useCommonUI)(),
    AdvanceTable = _useCommonUI.AdvanceTable;
  var _AdvanceTable$useGrid = AdvanceTable.useGrid(),
    gridManagerRef = _AdvanceTable$useGrid.gridManagerRef,
    gridApiRef = _AdvanceTable$useGrid.gridApiRef,
    onGridReady = _AdvanceTable$useGrid.onGridReady;
  var _AdvanceTable$useRowS = AdvanceTable.useRowSelection(gridApiRef, (0, _extends2["default"])({}, rowSelectionOptions, {
      rowkey: _common.LOWCODE_NODE_ID
    })),
    rowSelection = _AdvanceTable$useRowS.rowSelection,
    selectedKeys = _AdvanceTable$useRowS.selectedKeys;
  schema['x-data'] = 'advance';
  var prefixCls = (0, _builtins__.usePrefixCls)('advance-content');
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var sources = (0, _common.useArrayTableSources)(field, schema, 'advance');
  var columns = (0, _common.useArrayTableColumns)(dataSource, field, sources);
  var addition = (0, _common.useAddition)(schema);
  var batchRemove = (0, _common.useBatchRemove)(schema);
  var _useState = (0, _react2.useState)(null),
    childrenNode = _useState[0],
    setChildrenNode = _useState[1];
  var onSelectionChanged = function onSelectionChanged(event) {
    var childrenNode = main.settings.getNode().document.getNode(event.selectedNodes[0].id);
    setChildrenNode(childrenNode);
  };
  var handleCellEditChange = (0, _hooks.useHandleCellEditChange)(valueMode, dataSource);
  console.log('---sources', sources, columns, dataSource);
  var handleRowDragEnd = function handleRowDragEnd(params) {
    var overIndex = params.overIndex,
      overNode = params.overNode;
    var node = selected.document.getNodeById(overNode.id);
    var nodeIndex = selected.children.indexOf(node);
    selected.children.insert(node, overIndex > nodeIndex ? overIndex + 1 : overIndex);
  };
  var children = wrapSSR(/*#__PURE__*/_react2["default"].createElement("div", {
    ref: slotRef,
    className: (0, _classnames["default"])(prefixCls, hashId)
  }, /*#__PURE__*/_react2["default"].createElement("div", {
    className: prefixCls + "-left"
  }, /*#__PURE__*/_react2["default"].createElement(_space["default"], {
    className: (0, _classnames["default"])(prefixCls + "-toobar")
  }, addition, batchRemove, /*#__PURE__*/_react2["default"].createElement(_sideContent.SideContent, null)), /*#__PURE__*/_react2["default"].createElement(AdvanceTable, (0, _extends2["default"])({
    editable: true,
    autoHeight: true,
    animateRows: true,
    rowMultiSelectWithClick: false,
    stopEditingWhenCellsLoseFocus: true,
    rowDragManaged: true
  }, props, {
    rowkey: _common.LOWCODE_NODE_ID,
    rowSelection: rowSelection,
    onReady: onGridReady,
    columns: columns,
    dataSource: dataSource,
    onCellEditChange: handleCellEditChange,
    onSelectionChanged: onSelectionChanged,
    onRowDragEnd: handleRowDragEnd
  })), sources.map(function (column, key) {
    if (!(0, _common.isColumnComponent)(column.schema)) return;
    return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
      name: column.name,
      schema: column.schema,
      onlyRenderSelf: true,
      key: key
    });
  })), /*#__PURE__*/_react2["default"].createElement("div", {
    className: prefixCls + "-right"
  }, /*#__PURE__*/_react2["default"].createElement(ChildrenSettings, {
    childrenNode: childrenNode
  }))));
  return /*#__PURE__*/_react2["default"].createElement(_common.GridManagerContext.Provider, {
    value: gridManagerRef
  }, /*#__PURE__*/_react2["default"].createElement(_common.RowSelectedContext.Provider, {
    value: selectedKeys
  }, /*#__PURE__*/_react2["default"].createElement(_context.SubSlotProvider, {
    value: slotRef
  }, children)));
});