"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = exports.ArrayAdvanceTable = void 0;
var _button = _interopRequireDefault(require("antd/lib/button"));
var _space = _interopRequireDefault(require("antd/lib/space"));
var _extends3 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _core = require("@formily/core");
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _hooks = require("../../../../hooks");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _reactDom = require("react-dom");
var _context = require("../../context");
var _common = require("./common");
var _advanceContent = require("./advance-content");
var _validatorSetter = require("../validator-setter");
var _hooks2 = require("./hooks");
var _excluded = ["valueMode", "className", "rowSelectionOptions"],
  _excluded2 = ["drawerProps"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var InternalArrayAdvanceTable = (0, _react.observer)(function (_ref) {
  var valueMode = _ref.valueMode,
    className = _ref.className,
    rowSelectionOptions = _ref.rowSelectionOptions,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var ref = (0, _react2.useRef)(null);
  var field = (0, _react.useField)();
  var schema = (0, _react.useFieldSchema)();
  var selected = (0, _hooks.useSelected)();
  var _useCommonUI = (0, _hooks.useCommonUI)(),
    AdvanceTable = _useCommonUI.AdvanceTable;
  var _AdvanceTable$useGrid = AdvanceTable.useGrid(),
    gridManagerRef = _AdvanceTable$useGrid.gridManagerRef,
    gridApiRef = _AdvanceTable$useGrid.gridApiRef,
    onGridReady = _AdvanceTable$useGrid.onGridReady;
  var _AdvanceTable$useRowS = AdvanceTable.useRowSelection(gridApiRef, (0, _extends3["default"])({}, rowSelectionOptions, {
      rowkey: _common.LOWCODE_NODE_ID
    })),
    rowSelection = _AdvanceTable$useRowS.rowSelection,
    clearRowSelection = _AdvanceTable$useRowS.clearRowSelection,
    selectedKeys = _AdvanceTable$useRowS.selectedKeys,
    selectedRows = _AdvanceTable$useRowS.selectedRows;
  schema['x-data'] = 'normal';
  var prefixCls = (0, _builtins__.usePrefixCls)('array-avance-table');
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var open = useOpen();
  (0, _react2.useMemo)(function () {
    if (!valueMode || valueMode === 'normal') return;
    var value = [];
    selected.children.forEach(function (child) {
      var _extends2;
      value.push((0, _extends3["default"])({}, child.propsData, (_extends2 = {}, _extends2[_common.LOWCODE_NODE_ID] = child.id, _extends2)));
    });
    field.setValue(value);
  }, []);
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  dataSource.forEach(function (item, index) {
    item[_common.indexKey] = index;
  });
  (0, _react2.useEffect)(function () {
    var effects = function effects() {
      (0, _core.onFieldValueChange)(field.path.toString() + '.*', function (dataField) {
        var value = dataField.value;
        var key = dataField.path.toArr();
        var name = key[0],
          index = key[1],
          path = key.slice(2);
        selected.children.get(index).setPropValue(path.join('.'), value);
      });
    };
    field.form.addEffects('node-children-array-table', effects);
    return function () {
      field.form.removeEffects('node-children-array-table');
    };
  }, [field, selected]);
  var sources = (0, _common.useArrayTableSources)(field, schema);
  var columns = (0, _common.useArrayTableColumns)(dataSource, field, sources);
  var addition = (0, _common.useAddition)(schema);
  var batchRemove = (0, _common.useBatchRemove)(schema);
  console.log('---selectedKeys', selectedKeys);
  console.log('---columns', columns);
  console.log('---dataSource', dataSource);
  var handleCellEditChange = (0, _hooks2.useHandleCellEditChange)(valueMode, dataSource);
  var handleRowDragEnd = function handleRowDragEnd(params) {
    var overIndex = params.overIndex,
      overNode = params.overNode;
    var node = selected.document.getNodeById(overNode.id);
    var nodeIndex = selected.children.indexOf(node);
    selected.children.insert(node, overIndex > nodeIndex ? overIndex + 1 : overIndex);
  };
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_common.ValueModeContext.Provider, {
    value: valueMode
  }, /*#__PURE__*/_react2["default"].createElement(_common.GridManagerContext.Provider, {
    value: gridManagerRef
  }, /*#__PURE__*/_react2["default"].createElement(_common.RowSelectedContext.Provider, {
    value: selectedKeys
  }, /*#__PURE__*/_react2["default"].createElement("div", {
    ref: ref,
    className: (0, _classnames["default"])(prefixCls, hashId)
  }, /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase, null, /*#__PURE__*/_react2["default"].createElement(_space["default"], {
    className: (0, _classnames["default"])(prefixCls + "-toobar")
  }, addition, batchRemove), /*#__PURE__*/_react2["default"].createElement(AdvanceTable, (0, _extends3["default"])({
    editable: true,
    autoHeight: true,
    animateRows: true,
    rowMultiSelectWithClick: false,
    suppressSelectedBox: true,
    stopEditingWhenCellsLoseFocus: true,
    rowDragManaged: true
  }, props, {
    selectionColumnDef: {
      minWidth: 25,
      width: 25,
      maxWidth: 25
    },
    rowkey: _common.LOWCODE_NODE_ID,
    rowSelection: rowSelection,
    onReady: onGridReady,
    className: (0, _classnames["default"])(prefixCls + "-grid", className),
    columns: columns,
    dataSource: dataSource,
    onCellEditChange: handleCellEditChange,
    onRowDragEnd: handleRowDragEnd
  })), sources.map(function (column, key) {
    // 专门用来承接对Column的状态管理
    if (!(0, _common.isColumnComponent)(column.schema)) return;
    return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
      name: column.name,
      schema: column.schema,
      onlyRenderSelf: true,
      key: key
    });
  }), open))))));
});
var isOpenComponent = function isOpenComponent(schema) {
  var _schema$xComponent;
  return ((_schema$xComponent = schema['x-component']) === null || _schema$xComponent === void 0 ? void 0 : _schema$xComponent.indexOf('Open')) > -1;
};
var useOpen = function useOpen() {
  var schema = (0, _react.useFieldSchema)();
  return schema.reduceProperties(function (open, schema, key) {
    if (isOpenComponent(schema)) {
      return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        schema: schema,
        name: key
      });
    }
    return open;
  }, null);
};
var Open = /*#__PURE__*/(0, _react2.forwardRef)(function (_ref2, ref) {
  var _array$field, _array$field2;
  var drawerProps = _ref2.drawerProps,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded2);
  var _useSlot = (0, _context.useSlot)(),
    slotRef = _useSlot.slotRef;
  var _useState = (0, _react2.useState)(false),
    open = _useState[0],
    setOpen = _useState[1];
  var showDrawer = function showDrawer() {
    setOpen(true);
  };
  var onClose = function onClose() {
    setOpen(false);
  };
  var _useCommonUI2 = (0, _hooks.useCommonUI)(),
    Drawer = _useCommonUI2.Drawer;
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var prefixCls = (0, _builtins__.usePrefixCls)('array-avance-table');
  var _useStyle2 = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  if (!array) return null;
  if (((_array$field = array.field) === null || _array$field === void 0 ? void 0 : _array$field.pattern) !== 'editable' && ((_array$field2 = array.field) === null || _array$field2 === void 0 ? void 0 : _array$field2.pattern) !== 'disabled') return null;
  var openButton = wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends3["default"])({
    type: "ghost"
  }, props, {
    style: (0, _extends3["default"])({
      padding: '0 6px 0 6px',
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: (0, _classnames["default"])(prefixCls + "-open", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-open-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _array$props;
      if ((_array$props = array.props) !== null && _array$props !== void 0 && _array$props.disabled) return;
      showDrawer();
      if (props.onClick) {
        props.onClick(e);
      }
    },
    icon: (0, _shared.isUndef)(props.icon) ? (0, _lowcodeUtils.createIcon)('fullscreen1') : props.icon
  }), props.title || self.title));
  var drawer = /*#__PURE__*/_react2["default"].createElement(Drawer, (0, _extends3["default"])({}, drawerProps, {
    scrollBar: false,
    wrapperBody: false,
    push: false,
    className: (0, _classnames["default"])(prefixCls + "-advance-drawer", drawerProps.className),
    classNames: {
      body: prefixCls + "-advance-drawer-body"
    },
    onClose: onClose,
    open: open
  }), /*#__PURE__*/_react2["default"].createElement(_react.RecordsScope, {
    getRecords: function getRecords() {
      return array.field.value;
    }
  }, /*#__PURE__*/_react2["default"].createElement(_react.FieldContext.Provider, {
    value: array.field
  }, /*#__PURE__*/_react2["default"].createElement(_react.SchemaContext.Provider, {
    value: array.schema
  }, /*#__PURE__*/_react2["default"].createElement(_advanceContent.AdvanceContent, array.field.componentProps)))));
  if (slotRef.current) {
    return /*#__PURE__*/_react2["default"].createElement(_react2["default"].Fragment, null, /*#__PURE__*/(0, _reactDom.createPortal)(openButton, slotRef.current), drawer);
  }
  return /*#__PURE__*/_react2["default"].createElement(_react2["default"].Fragment, null, openButton, drawer);
});
var ArrayAdvanceTable = exports.ArrayAdvanceTable = Object.assign(_antdV.ArrayBase.mixin(InternalArrayAdvanceTable), {
  Column: _common.Column,
  Addition: _common.Addition,
  Navigation: _common.Navigation,
  Open: Open,
  ValidatorSetter: _validatorSetter.ValidatorSetter,
  Action: _common.Action,
  SortHandle: _common.SortHandle,
  SidePanel: _common.SidePanel,
  BatchRemove: _common.BatchRemove
});
ArrayAdvanceTable.displayName = 'ArrayAdvanceTable';
var _default = exports["default"] = ArrayAdvanceTable;