"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.useIndex = exports.SideItemContext = exports.SideContent = exports.SideBaseContext = exports.RulePathContext = exports.Addition = void 0;
var _dropdown = _interopRequireDefault(require("antd/lib/dropdown"));
var _drawer = _interopRequireDefault(require("antd/lib/drawer"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _collapse = _interopRequireDefault(require("antd/lib/collapse"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _card = _interopRequireDefault(require("antd/lib/card"));
var _empty = _interopRequireDefault(require("antd/lib/empty"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = require("react");
var _style = _interopRequireWildcard(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _common = require("../common");
var _lodash = require("lodash");
var _icons = require("@ant-design/icons");
var _context = require("../../../context");
var _hooks = require("../../../../../hooks");
var _excluded = ["children"],
  _excluded2 = ["setOpen"],
  _excluded3 = ["onClick"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var range = function range(count) {
  return Array.from({
    length: count
  }).map(function (_, i) {
    return i;
  });
};
var takeDefaultActiveKeys = function takeDefaultActiveKeys(dataSourceLength, defaultOpenPanelCount) {
  if (dataSourceLength < defaultOpenPanelCount) return range(dataSourceLength);
  return range(defaultOpenPanelCount);
};
var insertActiveKeys = function insertActiveKeys(activeKeys, index) {
  if (activeKeys.length <= index) return activeKeys.concat(index);
  return activeKeys.reduce(function (buf, key) {
    if (key < index) return buf.concat(key);
    if (key === index) return buf.concat([key, key + 1]);
    return buf.concat(key + 1);
  }, []);
};
var SideBaseContext = exports.SideBaseContext = /*#__PURE__*/(0, _react2.createContext)(null);
var RulePathContext = exports.RulePathContext = /*#__PURE__*/(0, _react2.createContext)(null);
var SideItemContext = exports.SideItemContext = /*#__PURE__*/(0, _react2.createContext)(null);
var SideContentItem = function SideContentItem(_ref) {
  var children = _ref.children,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  return /*#__PURE__*/React.createElement(SideItemContext.Provider, {
    value: props
  }, children);
};
var SideContentDrawerContext = (0, _react.observer)(function (_ref2) {
  var _props$defaultOpenPan;
  var setOpen = _ref2.setOpen,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded2);
  var array = _antdV.ArrayBase.useArray();
  var schema = (0, _react.useFieldSchema)();
  var selected = (0, _hooks.useSelected)();
  var field = array.field;
  var _useState = (0, _react2.useState)(),
    stateActiveTabKey = _useState[0],
    setStateActiveTabKey = _useState[1];
  var prefixCls = (0, _builtins__.usePrefixCls)('side-content', props);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var onTab1Change = function onTab1Change(key) {
    setStateActiveTabKey(key);
  };
  var _useState2 = (0, _react2.useState)(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan !== void 0 ? _props$defaultOpenPan : Infinity)),
    activeKeys = _useState2[0],
    setActiveKeys = _useState2[1];
  (0, _react2.useEffect)(function () {
    if (!field.modified && dataSource.length) {
      var _props$defaultOpenPan2;
      setActiveKeys(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan2 = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan2 !== void 0 ? _props$defaultOpenPan2 : Infinity));
    }
  }, [dataSource.length, field]);
  if (!schema) throw new Error('can not found schema object');
  var itemsSchema = Array.isArray(array.schema.items) ? array.schema.items[0] : array.schema.items;
  var _ref3 = function () {
      var schema,
        path = '';
      itemsSchema.mapProperties(function (item) {
        if ((0, _common.isSidePanelComponent)(item)) {
          schema = item;
          path = Object.keys(item.properties)[0];
        }
      });
      return [schema, path];
    }(),
    sideSchema = _ref3[0],
    rulePath = _ref3[1];
  var definitions = selected.getStatementStateDefinitions(selected.id);
  var tabList = undefined;
  var isStateRules = definitions && !(0, _lodash.isEmpty)(definitions);
  var currentTabKey = '';
  if (isStateRules) {
    var _Object$keys;
    // field.form.clearFormGraph(`${field.address}.*.${rulePath}`);
    currentTabKey = stateActiveTabKey || ((_Object$keys = Object.keys(definitions)) === null || _Object$keys === void 0 ? void 0 : _Object$keys[0]);
    rulePath = rulePath + "__state__." + currentTabKey;
    tabList = Object.entries(definitions).map(function (_ref4) {
      var key = _ref4[0],
        tab = _ref4[1];
      return {
        key: key,
        tab: tab
      };
    });
    // 构建状态 schema
    itemsSchema = new _react.Schema(itemsSchema.toJSON());
    itemsSchema.mapProperties(function (schema) {
      if (!(0, _common.isSidePanelComponent)(schema)) return;
      schema.mapProperties(function (childSchema) {
        var _properties, _stateSchema;
        var stateSchema = (_stateSchema = {}, _stateSchema[childSchema.name + "__state__"] = {
          type: 'object',
          properties: (_properties = {}, _properties[currentTabKey] = childSchema.toJSON(), _properties)
        }, _stateSchema);
        schema.setProperties(stateSchema);
        schema.removeProperty(childSchema.name);
      });
    });
  }
  var isRuleEmpty = dataSource.filter(function (item) {
    return (0, _lodash.get)(item, rulePath);
  }).length === 0;
  var renderEmpty = function renderEmpty() {
    if (!isRuleEmpty) return;
    return /*#__PURE__*/React.createElement(_card["default"], {
      className: (0, _classnames["default"])(prefixCls + "-item", hashId, props.className)
    }, /*#__PURE__*/React.createElement(_empty["default"], {
      description: "\u6682\u65E0\u6821\u9A8C\u89C4\u5219"
    }));
  };
  var fieldNames = array.field.componentProps.fieldNames || {
    label: 'label',
    value: 'value'
  };
  var renderItems = function renderItems() {
    if (isRuleEmpty) return null;
    return dataSource.map(function (item, index) {
      if (!(0, _lodash.get)(item, rulePath)) return null;
      var header = (0, _lodash.get)(item, fieldNames.label);
      var content = /*#__PURE__*/React.createElement(SideContentItem, {
        index: index,
        key: index,
        record: item
      }, /*#__PURE__*/React.createElement(_antdV.ArrayBase.Item, {
        index: index,
        key: index,
        record: item
      }, /*#__PURE__*/React.createElement(_react.RecursionField, {
        schema: itemsSchema,
        name: index,
        filterProperties: function filterProperties(schema) {
          if ((0, _common.isSidePanelComponent)(schema)) {
            return true;
          }
          return false;
        }
      })));
      return /*#__PURE__*/React.createElement(_collapse["default"], (0, _extends2["default"])({}, props, {
        key: index,
        ghost: true,
        expandIconPosition: "end",
        activeKey: activeKeys,
        onChange: function onChange(keys) {
          setActiveKeys((0, _shared.toArr)(keys).map(Number));
        },
        className: (0, _classnames["default"])(prefixCls + "-item", prefixCls + "-collapse", props.className),
        items: [{
          key: index,
          label: header,
          children: content
        }]
      }));
    });
  };
  return wrapSSR(/*#__PURE__*/React.createElement(_card["default"], {
    className: (0, _classnames["default"])(prefixCls, hashId),
    title: props.title,
    classNames: {
      header: prefixCls + "-drawer-header",
      body: prefixCls + "-drawer-body"
    },
    extra: /*#__PURE__*/React.createElement(_icons.CloseOutlined, {
      onClick: function onClick() {
        return setOpen(false);
      }
    }),
    tabList: tabList,
    tabProps: {
      size: 'small'
    },
    onTabChange: onTab1Change
  }, /*#__PURE__*/React.createElement(SideBaseContext.Provider, {
    value: {
      field: field,
      schema: schema,
      props: {}
    }
  }, /*#__PURE__*/React.createElement(RulePathContext.Provider, {
    value: rulePath
  }, /*#__PURE__*/React.createElement(_antdV.ArrayBase, {
    onAdd: function onAdd(index) {
      setActiveKeys(insertActiveKeys(activeKeys, index));
    }
  }, renderEmpty(), renderItems(), /*#__PURE__*/React.createElement(Addition, null))))));
});
var SideContent = exports.SideContent = (0, _react.observer)(function (props) {
  var array = _antdV.ArrayBase.useArray();
  var schema = (0, _react.useFieldSchema)();
  var _useState3 = (0, _react2.useState)(false),
    open = _useState3[0],
    setOpen = _useState3[1];
  var slotRef = (0, _context.useSubSlotRef)();
  var prefixCls = (0, _builtins__.usePrefixCls)('side-content-drawer', props);
  var _useSideDrawerStyle = (0, _style.useSideDrawerStyle)(prefixCls),
    wrapSSR = _useSideDrawerStyle[0],
    hashId = _useSideDrawerStyle[1];
  if (!schema) throw new Error('can not found schema object');
  var itemsSchema = Array.isArray(array.schema.items) ? array.schema.items[0] : array.schema.items;
  var _props = {
    title: ''
  };
  itemsSchema.mapProperties(function (schema) {
    if ((0, _common.isSidePanelComponent)(schema)) {
      _props = schema['x-component-props'];
    }
  });
  return wrapSSR(/*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(_button["default"], {
    color: "primary",
    variant: "filled",
    size: "small",
    onClick: function onClick() {
      setOpen(true);
    }
  }, _props.title), /*#__PURE__*/React.createElement(_drawer["default"], {
    width: 400,
    open: open,
    rootStyle: {
      position: 'absolute'
    },
    push: false,
    onClose: function onClose() {
      return setOpen(false);
    },
    getContainer: function getContainer() {
      return slotRef.current;
    },
    mask: false,
    rootClassName: (0, _classnames["default"])(prefixCls, hashId),
    classNames: {
      header: prefixCls + "-drawer-header"
    }
  }, /*#__PURE__*/React.createElement(SideContentDrawerContext, (0, _extends2["default"])({
    setOpen: setOpen
  }, _props)))));
});
var Addition = exports.Addition = (0, _react.observer)(function (_ref5) {
  var onClick = _ref5.onClick,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref5, _excluded3);
  var array = _antdV.ArrayBase.useArray();
  var value = array.field.value || [];
  var fieldNames = array.field.componentProps.fieldNames || {
    label: 'label',
    value: 'value'
  };
  var rulePath = (0, _react2.useContext)(RulePathContext);
  var dataSource = value.filter(function (item) {
    return item && (0, _lodash.get)(item, fieldNames.label) && (0, _lodash.get)(item, fieldNames.value);
  });
  var rules = value.filter(function (item) {
    return item && (0, _lodash.get)(item, rulePath);
  });
  var len = rules.length;
  var items = value.reduce(function (options, item, index) {
    var label = (0, _lodash.get)(item, fieldNames.label);
    if (item && (0, _lodash.get)(item, fieldNames.label) && (0, _lodash.get)(item, fieldNames.value) && !rules.some(function (item) {
      return (0, _lodash.get)(item, fieldNames.label) === label;
    })) {
      options.push({
        label: label,
        key: index
      });
    }
    return options;
  }, []);
  if (dataSource.length === len) return null;
  var onDropdownClick = function onDropdownClick(menuInfo) {
    var key = menuInfo.key;
    (0, _lodash.set)(value, key + "." + rulePath, []);
    if (onClick) {
      onClick(menuInfo);
    }
  };
  return /*#__PURE__*/React.createElement(_dropdown["default"], {
    menu: {
      items: items,
      onClick: onDropdownClick
    },
    trigger: ['click']
  }, /*#__PURE__*/React.createElement(_button["default"], (0, _extends2["default"])({
    color: "primary",
    variant: "filled"
  }, props), "\u6DFB\u52A0\u9A8C\u8BC1\u5B57\u6BB5"));
});
var useIndex = exports.useIndex = function useIndex(index) {
  var ctx = (0, _react2.useContext)(SideItemContext);
  return ctx ? ctx.index : index;
};