"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.DrawerSetter = void 0;
var _button = _interopRequireDefault(require("antd/lib/button"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _reactDom = require("react-dom");
var _react2 = require("@formily/react");
var _antdV = require("@formily/antd-v5");
var _classnames = _interopRequireDefault(require("classnames"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var DrawerSetter = exports.DrawerSetter = (0, _react2.observer)(function (props) {
  var field = (0, _react2.useField)();
  var _useState = (0, _react.useState)(false),
    visible = _useState[0],
    setVisible = _useState[1];
  var _useState2 = (0, _react.useState)(false),
    remove = _useState2[0],
    setRemove = _useState2[1];
  var _useState3 = (0, _react.useState)(),
    root = _useState3[0],
    setRoot = _useState3[1];
  var prefixCls = (0, _builtins__.usePrefixCls)('drawer-setter', props);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var formWrapperCls = (0, _builtins__.usePrefixCls)('settings-form-wrapper');
  (0, _react.useLayoutEffect)(function () {
    var wrapper = document.querySelector('.' + formWrapperCls);
    if (wrapper) {
      setRoot(wrapper);
    }
  }, []);
  var renderDrawer = function renderDrawer() {
    if (root && visible) {
      return /*#__PURE__*/(0, _reactDom.createPortal)(wrapSSR(/*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(prefixCls, hashId, 'animate__animated animate__slideInRight', {
          animate__slideOutRight: remove
        })
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls + '-header',
        onClick: handleClose
      }, (0, _lowcodeUtils.createIcon)('houtui', {
        className: prefixCls + '-header-back'
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: prefixCls + '-header-text'
      }, props.text || field.title)), /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls + '-body'
      }, /*#__PURE__*/_react["default"].createElement(_antdV.FormLayout, {
        colon: false,
        labelWidth: 120,
        labelAlign: "left",
        wrapperAlign: "right",
        feedbackLayout: "none",
        tooltipLayout: "text"
      }, props.children)))), root);
    }
    return null;
  };
  var handleOpen = function handleOpen() {
    setVisible(true);
  };
  var handleClose = function handleClose() {
    setRemove(true);
    setTimeout(function () {
      setVisible(false);
      setRemove(false);
    }, 150);
  };
  return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(_button["default"], (0, _extends2["default"])({
    block: true,
    onClick: handleOpen
  }, props.triggerProps), props.text || field.title), renderDrawer());
});