"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ExpressionSetter = void 0;
var _modal = _interopRequireDefault(require("antd/lib/modal"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _tree = _interopRequireDefault(require("antd/lib/tree"));
var _row = _interopRequireDefault(require("antd/lib/row"));
var _input = _interopRequireDefault(require("antd/lib/input"));
var _col = _interopRequireDefault(require("antd/lib/col"));
var _switch = _interopRequireDefault(require("antd/lib/switch"));
var _segmented = _interopRequireDefault(require("antd/lib/segmented"));
var _form = _interopRequireDefault(require("antd/lib/form"));
var _react = _interopRequireWildcard(require("react"));
var _lodash = require("lodash");
var _ahooks = require("ahooks");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _monacoInput = require("../monaco-input");
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _style = require("./style");
var _hooks = require("../../../../hooks");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var paramTreeData = [{
  title: '项目 (Part)',
  key: 'part',
  children: [{
    title: '系统变量',
    key: 'system',
    children: [{
      title: 'currentUser (当前用户)',
      key: 'currentUser'
    }]
  }, {
    title: '状态变量',
    key: 'status',
    children: [{
      title: 'opType (模式)',
      key: 'opType'
    }]
  }, {
    title: '传参项',
    key: 'params',
    children: [{
      title: 'productId (产品)',
      key: 'productId'
    }]
  }, {
    title: '数据源',
    key: 'data',
    children: [{
      title: 'statusProvider',
      key: 'statusProvider'
    }]
  }, {
    title: '查询结果',
    key: 'result',
    children: [{
      title: 'formData',
      key: 'formData',
      children: [{
        title: 'product (产品)',
        key: 'product'
      }, {
        title: 'productNode (变更产品)',
        key: 'productNode'
      }]
    }]
  }]
}];
var options = [{
  value: 'expression',
  label: '表达式'
}, {
  value: 'boolean',
  label: '布尔值'
}, {
  value: 'ternary',
  label: '三元表达式'
}
// {
//   value: 'logic',
//   label: '逻辑判断',
// },
// {
//   value: 'custom',
//   label: '自定义函数',
// },
];
var ExpressionWidget = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var value = _ref.value,
    onChange = _ref.onChange;
  console.log('LogicWidget--value', value);
  var _Form$useForm = _form["default"].useForm(),
    form = _Form$useForm[0];
  var onFormValueChange = function onFormValueChange(changedValues, values) {
    console.log('onFormValueChange--values', changedValues, values);
    onChange === null || onChange === void 0 ? void 0 : onChange(values);
  };
  return /*#__PURE__*/_react["default"].createElement(_row["default"], null, /*#__PURE__*/_react["default"].createElement(_col["default"], {
    span: 16
  }, /*#__PURE__*/_react["default"].createElement(_segmented["default"], {
    options: options,
    onChange: function onChange(value) {
      console.log(value); // string
    }
  }), /*#__PURE__*/_react["default"].createElement(_form["default"], {
    form: form,
    initialValues: value,
    onValuesChange: onFormValueChange,
    style: {
      maxWidth: 'none'
    }
  }, /*#__PURE__*/_react["default"].createElement(_form["default"].Item, {
    name: "value"
  }, /*#__PURE__*/_react["default"].createElement(_monacoInput.MonacoInput, {
    height: 200,
    language: "javascript.expression",
    helpLink: false
  })), /*#__PURE__*/_react["default"].createElement(_row["default"], null, /*#__PURE__*/_react["default"].createElement(_col["default"], {
    flex: 1
  }, /*#__PURE__*/_react["default"].createElement(_form["default"].Item, {
    label: "\u4F5C\u4E3A\u9875\u9762\u53D8\u91CF",
    name: "isFixed"
  }, /*#__PURE__*/_react["default"].createElement(_switch["default"], null))), /*#__PURE__*/_react["default"].createElement(_col["default"], {
    flex: 1
  }, /*#__PURE__*/_react["default"].createElement(_form["default"].Item, {
    label: "\u53D8\u91CF\u540D",
    name: "variableName"
  }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
    placeholder: "\u53D8\u91CF\u540D"
  })))))), /*#__PURE__*/_react["default"].createElement(_col["default"], null, /*#__PURE__*/_react["default"].createElement(_tree["default"], {
    treeData: paramTreeData,
    defaultExpandAll: true
  })));
});
var ExpressionSetter = exports.ExpressionSetter = /*#__PURE__*/(0, _react.memo)(function (props) {
  var className = props.className,
    style = props.style;
  var selected = (0, _hooks.useSelected)();
  var prefixCls = (0, _builtins__.usePrefixCls)('expression-setter', props);
  var _useStyle = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var _useControllableValue = (0, _ahooks.useControllableValue)(props, {
      defaultValue: {
        expression: ''
      }
    }),
    value = _useControllableValue[0],
    onChange = _useControllableValue[1];
  var _useState = (0, _react.useState)(false),
    isModalOpen = _useState[0],
    setIsModalOpen = _useState[1];
  var showModal = function showModal() {
    setIsModalOpen(true);
  };
  var handleOk = function handleOk() {
    var _props$onChange;
    if (value.isFixed) {
      console.log('作为页面变量', selected);
      // selected.document.root?.getExtraProp('statements').add();
    }
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, (0, _extends2["default"])({
      type: 'JSExpression'
    }, value));
    setIsModalOpen(false);
  };
  var handleCancel = function handleCancel() {
    setIsModalOpen(false);
  };
  return wrapSSR(/*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls, hashId, className),
    style: style,
    onClick: showModal
  }, (0, _lowcodeUtils.createIcon)('fx', {
    className: (0, _classnames["default"])(prefixCls + "-icon", {
      active: (0, _lodash.isObject)(value) && value.type === 'JSExpression'
    })
  })), /*#__PURE__*/_react["default"].createElement(_modal["default"], {
    title: "\u903B\u8F91\u7F16\u8F91\u5668",
    open: isModalOpen,
    onCancel: handleCancel,
    onOk: handleOk,
    width: 900
  }, /*#__PURE__*/_react["default"].createElement(ExpressionWidget, (0, _extends2["default"])({}, props, {
    value: value,
    onChange: onChange
  })))));
});