"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.FormCard = exports.Card = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _antdV = require("@formily/antd-v5");
var _classnames = _interopRequireDefault(require("classnames"));
var _style = _interopRequireDefault(require("./style"));
var _hooks = require("../../../../__builtins__/hooks");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _react2 = require("@formily/react");
var _context = require("../../context");
var _excluded = ["className", "style", "children", "title", "defaultCollapsed", "collapse"],
  _excluded2 = ["className", "style", "children", "title", "defaultCollapsed", "collapse"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var Card = exports.Card = function Card(_ref) {
  var className = _ref.className,
    style = _ref.style,
    children = _ref.children,
    title = _ref.title,
    _ref$defaultCollapsed = _ref.defaultCollapsed,
    defaultCollapsed = _ref$defaultCollapsed === void 0 ? true : _ref$defaultCollapsed,
    collapse = _ref.collapse,
    restProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var slotRef = (0, _react.useRef)(null);
  var field = (0, _react2.useField)();
  var _useState = (0, _react.useState)(defaultCollapsed),
    collapsed = _useState[0],
    setCollapsed = _useState[1];
  var prefixCls = (0, _hooks.usePrefixCls)('settings-card', restProps);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var toggleCollapse = function toggleCollapse() {
    if (collapse) {
      setCollapsed(!collapsed);
    }
  };
  // 判断头部是否需要显示
  var headerTitle = field.title || title;
  return wrapSSR(/*#__PURE__*/_react["default"].createElement(_context.SlotProvider, {
    value: {
      slotRef: slotRef
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-layout", hashId, className, {
      active: collapsed,
      collapse: collapse
    }),
    style: style
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-header", {
      hasTitle: !!headerTitle
    }),
    onClick: toggleCollapse
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls + "-title"
  }, headerTitle), /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls + "-header-slot",
    ref: slotRef
  }), collapse && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-collapse")
  }, (0, _lowcodeUtils.createIcon)('arrow-down', {
    size: 'xs',
    className: prefixCls + "-icon"
  }))), /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls + "-wrapper"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls + "-body"
  }, children)))));
};
var FormCard = exports.FormCard = function FormCard(_ref2) {
  var className = _ref2.className,
    style = _ref2.style,
    children = _ref2.children,
    title = _ref2.title,
    _ref2$defaultCollapse = _ref2.defaultCollapsed,
    defaultCollapsed = _ref2$defaultCollapse === void 0 ? true : _ref2$defaultCollapse,
    collapse = _ref2.collapse,
    restProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(Card, {
    title: title,
    defaultCollapsed: defaultCollapsed,
    collapse: collapse,
    className: className,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_antdV.FormLayout, restProps, children));
};