"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = exports.FormRow = void 0;
var _row = _interopRequireDefault(require("antd/lib/row"));
var _col = _interopRequireDefault(require("antd/lib/col"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _react2 = require("@formily/react");
var _classnames = _interopRequireDefault(require("classnames"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _excluded = ["children", "className", "style"];
var useCols = function useCols() {
  var colsField = (0, _react2.useField)();
  var schema = (0, _react2.useFieldSchema)();
  var cols = [];
  schema.mapProperties(function (schema, name) {
    var _schema$xComponent;
    var field = colsField.query(colsField.address.concat(name)).take();
    if ((field === null || field === void 0 ? void 0 : field.display) === 'none' || (field === null || field === void 0 ? void 0 : field.display) === 'hidden') return;
    if (((_schema$xComponent = schema['x-component']) === null || _schema$xComponent === void 0 ? void 0 : _schema$xComponent.indexOf('Col')) > -1) {
      var _schema$xComponentP;
      cols.push({
        name: name,
        props: (0, _extends2["default"])({
          key: (schema === null || schema === void 0 ? void 0 : (_schema$xComponentP = schema['x-component-props']) === null || _schema$xComponentP === void 0 ? void 0 : _schema$xComponentP.key) || name
        }, schema === null || schema === void 0 ? void 0 : schema['x-component-props']),
        schema: schema
      });
    }
  });
  return cols;
};
var FormRow = exports.FormRow = (0, _react2.observer)(function (_ref) {
  var children = _ref.children,
    className = _ref.className,
    style = _ref.style,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var prefixCls = (0, _builtins__.usePrefixCls)('formily-row', props);
  var cols = useCols();
  return /*#__PURE__*/_react["default"].createElement(_row["default"], (0, _extends2["default"])({}, props, {
    className: (0, _classnames["default"])(prefixCls, className)
  }), cols.map(function (_ref2, index) {
    var props = _ref2.props,
      schema = _ref2.schema,
      name = _ref2.name;
    return /*#__PURE__*/_react["default"].createElement(_col["default"], (0, _extends2["default"])({
      key: index
    }, props), /*#__PURE__*/_react["default"].createElement(_react2.RecursionField, {
      schema: schema,
      name: name
    }));
  }));
}, {
  forwardRef: true
});
var FormCol = function FormCol(_ref3) {
  var children = _ref3.children;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, children);
};
FormRow.Col = FormCol;
var _default = exports["default"] = FormRow;