"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.MixedSetter = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _react2 = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _style = require("./style");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _useEvent = require("../../../../hooks/useEvent");
var _hooks = require("../../../../hooks");
var _excluded = ["className", "style", "setters"];
function nomalizeSetters(setters) {
  return setters.map(function (item) {
    if (typeof item === 'string') {
      return {
        'x-component': item,
        title: item
      };
    }
    return item;
  });
}
var isHTMLInputEvent = function isHTMLInputEvent(event, stopPropagation) {
  if (stopPropagation === void 0) {
    stopPropagation = true;
  }
  if (event !== null && event !== void 0 && event.target) {
    var _event$stopPropagatio;
    if (typeof event.target === 'object' && ('value' in event.target || 'checked' in event.target)) return true;
    if (stopPropagation) (_event$stopPropagatio = event.stopPropagation) === null || _event$stopPropagatio === void 0 ? void 0 : _event$stopPropagatio.call(event);
  }
  return false;
};
var getValuesFromEvent = function getValuesFromEvent(args) {
  return args.map(function (event) {
    if (event !== null && event !== void 0 && event.target) {
      if ((0, _shared.isValid)(event.target.value)) return event.target.value;
      if ((0, _shared.isValid)(event.target.checked)) return event.target.checked;
      return;
    }
    return event;
  });
};
var isValidComponent = function isValidComponent(target) {
  return target && (typeof target === 'object' || typeof target === 'function');
};
var MixedSetter = exports.MixedSetter = function MixedSetter(_ref) {
  var className = _ref.className,
    style = _ref.style,
    setters = _ref.setters,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var event = (0, _useEvent.useEvent)();
  var field = (0, _react.useField)();
  var selected = (0, _hooks.useSelected)();
  var components = (0, _react2.useContext)(_react.SchemaComponentsContext);
  var prefixCls = (0, _builtins__.usePrefixCls)('mixed-setter');
  var _useStyle = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var getComponent = function getComponent(target) {
    var _FormPath$getIn;
    return isValidComponent(target) ? target : (_FormPath$getIn = _shared.FormPath.getIn(components, target)) !== null && _FormPath$getIn !== void 0 ? _FormPath$getIn : target;
  };
  var len = setters.length;
  var setterContent;
  var actions;
  var finalSetters = nomalizeSetters(setters);
  var getMockOrValue = function getMockOrValue(v) {
    if ((0, _lowcodeUtils.isJSExpression)(v)) {
      return v.mock;
    }
    return v;
  };
  var onBindChange = function onBindChange(value) {
    var _props$onChange;
    console.log('---value', value);
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, value);
  };
  var onChange = function onChange() {
    var getValues = function getValues(args) {
      var _args$;
      if ((_args$ = args[0]) !== null && _args$ !== void 0 && _args$.target) {
        if (!isHTMLInputEvent(args[0])) return args;
      }
      return getValuesFromEvent(args);
    };
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    var values = getValues(args);
    var value = values[0];
    if ((0, _lowcodeUtils.isJSExpression)(props.value)) {
      var _props$onChange2;
      (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 ? void 0 : _props$onChange2.call(props, (0, _extends2["default"])({}, props.value, {
        mock: value
      }));
    } else {
      var _props$onChange3;
      (_props$onChange3 = props.onChange) === null || _props$onChange3 === void 0 ? void 0 : _props$onChange3.call(props, value);
    }
  };
  var show = function show() {
    // 打开绑定变量面板
    event.emit('variableBind.open', (0, _extends2["default"])({}, props, {
      onChange: onBindChange
    }), field, selected);
  };
  if (len < 3) {
    if (len === 1) {
      var Setter = getComponent(finalSetters[0]['x-component']);
      setterContent = /*#__PURE__*/React.createElement(Setter, (0, _extends2["default"])({}, props, finalSetters[0]['x-component-props']));
    } else {
      var otherSetter = finalSetters.find(function (item) {
        return item['x-component'] !== 'VariableSetter';
      });
      var _Setter = getComponent(otherSetter['x-component']);
      setterContent = /*#__PURE__*/React.createElement(_Setter, (0, _extends2["default"])({}, props, otherSetter['x-component-props'], {
        value: getMockOrValue(props.value)
      }));
      actions = /*#__PURE__*/React.createElement("div", {
        onClick: show
      }, (0, _lowcodeUtils.createIcon)('fx', {
        className: (0, _classnames["default"])(prefixCls + "-icon", {
          active: (0, _lowcodeUtils.isJSExpression)(props.value)
        })
      }));
    }
  } else {}
  return wrapSSR(/*#__PURE__*/React.createElement(_react.FieldContext.Provider, {
    value: (0, _extends2["default"])({}, field, {
      value: getMockOrValue(props.value),
      onInput: onChange
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(prefixCls, hashId, className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-content")
  }, setterContent), /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-actions")
  }, actions))));
};