"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.initMonaco = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = require("@monaco-editor/react");
var _chrome = _interopRequireDefault(require("./themes/chrome"));
var _monokai = _interopRequireDefault(require("./themes/monokai"));
var _format = require("./format");
var initialized = false;
var initMonaco = exports.initMonaco = function initMonaco() {
  if (initialized) return;
  _react.loader.init().then(function (monaco) {
    monaco.editor.defineTheme('monokai', _monokai["default"]);
    monaco.editor.defineTheme('chrome-devtools', _chrome["default"]);
    monaco.languages.typescript.typescriptDefaults.setCompilerOptions({
      target: monaco.languages.typescript.ScriptTarget.Latest,
      allowNonTsExtensions: true,
      moduleResolution: monaco.languages.typescript.ModuleResolutionKind.NodeJs,
      module: monaco.languages.typescript.ModuleKind.CommonJS,
      noEmit: true,
      esModuleInterop: true,
      jsx: monaco.languages.typescript.JsxEmit.React,
      reactNamespace: 'React',
      allowJs: true
    });
    monaco.languages.typescript.typescriptDefaults.setDiagnosticsOptions({
      noSemanticValidation: false,
      noSyntaxValidation: true
    });
    monaco.languages.registerDocumentFormattingEditProvider('typescript', {
      provideDocumentFormattingEdits: function provideDocumentFormattingEdits(model) {
        return (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
          var _model$getDesignerLan;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _format.format)(((_model$getDesignerLan = model['getDesignerLanguage']) === null || _model$getDesignerLan === void 0 ? void 0 : _model$getDesignerLan.call(model)) || 'typescript', model.getValue());
              case 2:
                _context.t0 = _context.sent;
                _context.t1 = model.getFullModelRange();
                _context.t2 = {
                  text: _context.t0,
                  range: _context.t1
                };
                return _context.abrupt("return", [_context.t2]);
              case 6:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }))();
      }
    });
    initialized = true;
  });
};