"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.AdvanceContent = void 0;
var _table = _interopRequireDefault(require("antd/lib/table"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _context = require("../../../context");
var _common = require("../common");
var _sideContent = require("../side-content");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var AdvanceContent = exports.AdvanceContent = (0, _react.observer)(function (props) {
  var ref = (0, _react2.useRef)(null);
  var array = _antdV.ArrayBase.useArray();
  var _useState = (0, _react2.useState)(null),
    subSlot = _useState[0],
    setSubSlot = _useState[1];
  var schema = (0, _react.useFieldSchema)();
  schema['x-data'] = 'advance';
  var field = array.field;
  var prefixCls = (0, _builtins__.usePrefixCls)('advance-content');
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var sources = (0, _common.useArrayTableSources)(field, schema, 'advance');
  var columns = (0, _common.useArrayTableColumns)(dataSource, field, sources);
  var pagination = (0, _shared.isBool)(props.pagination) ? {} : props.pagination;
  var showPagination = (0, _shared.isBool)(props.pagination) ? props.pagination : true;
  var addition = (0, _common.useAddition)(schema);
  var defaultRowKey = function defaultRowKey(record) {
    return record[_common.indexKey];
  };
  console.log('---sources', sources, columns, dataSource);
  var children = wrapSSR(/*#__PURE__*/_react2["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls, hashId)
  }, /*#__PURE__*/_react2["default"].createElement("div", {
    className: prefixCls + "-left"
  }, /*#__PURE__*/_react2["default"].createElement(_common.ArrayTablePagination, (0, _extends2["default"])({}, pagination, {
    dataSource: dataSource,
    showPagination: showPagination
  }), function (dataSource, pager, _ref) {
    var startIndex = _ref.startIndex;
    return /*#__PURE__*/_react2["default"].createElement("div", {
      ref: ref
    }, /*#__PURE__*/_react2["default"].createElement(_table["default"], (0, _extends2["default"])({
      size: "small",
      bordered: true,
      rowKey: defaultRowKey
    }, props, {
      onChange: function onChange() {},
      pagination: false,
      columns: columns,
      dataSource: dataSource,
      components: {
        body: {
          wrapper: _common.WrapperComp,
          row: _common.RowComp
        }
      }
    })), /*#__PURE__*/_react2["default"].createElement("div", {
      style: {
        marginTop: 5,
        marginBottom: 5
      }
    }, pager), sources.map(function (column, key) {
      //专门用来承接对Column的状态管理
      if (!(0, _common.isColumnComponent)(column.schema)) return;
      return /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        name: column.name,
        schema: column.schema,
        onlyRenderSelf: true,
        key: key
      });
    }), addition);
  })), /*#__PURE__*/_react2["default"].createElement("div", {
    className: prefixCls + "-right"
  }, /*#__PURE__*/_react2["default"].createElement(_sideContent.SideContent, null))));
  return /*#__PURE__*/_react2["default"].createElement(_context.SubSlotProvider, {
    value: {
      setSubSlot: setSubSlot
    }
  }, children);
});