import { ArrayField, FieldDisplayTypes, GeneralField } from '@formily/core';
import { Schema } from '@formily/json-schema';
import { ReactFC } from '@formily/react';
import { ButtonProps, PaginationProps, SelectProps } from 'antd';
import { ColumnProps, ColumnsType } from 'antd/es/table';
import React from 'react';
import { ArrayBaseMixins } from '@formily/antd-v5';
interface ObservableColumnSource {
    field?: GeneralField;
    columnProps: ColumnProps<any>;
    schema: Schema;
    display: FieldDisplayTypes;
    name: string;
}
interface IArrayTablePaginationProps extends PaginationProps {
    dataSource?: any[];
    showPagination: boolean;
    children?: (dataSource: any[], pagination: React.ReactNode, options: {
        startIndex: number;
    }) => React.ReactElement;
}
interface IStatusSelectProps extends SelectProps<any> {
    pageSize?: number;
}
interface PaginationAction {
    totalPage?: number;
    pageSize?: number;
    startIndex?: number;
    changePage?: (page: number) => void;
}
export declare const isIndexComponent: (schema: Schema) => boolean;
export declare const isColumnComponent: (schema: Schema) => boolean;
export declare const isSidePanelComponent: (schema: Schema) => boolean;
export declare const isSideAdditionComponent: (schema: Schema) => boolean;
export declare const isOperationsComponent: (schema: Schema) => boolean;
export declare const isAdditionComponent: (schema: Schema) => boolean;
export declare const isOperationComponent: (schema: Schema) => boolean;
export declare const useArrayTableSources: (arrayField: ArrayField<any, any>, schema: Schema, mode?: 'normal' | 'advance') => ObservableColumnSource[];
export declare const LOWCODE_NODE_ID = "__lowcode_node_id__";
export declare const indexKey = "__DO_NOT_USE_THIS_PROPERTY_index__";
export declare const useArrayTableColumns: (dataSource: any[], field: ArrayField, sources: ObservableColumnSource[]) => ColumnsType<any>;
export declare const useAddition: (schema: Schema) => any;
export declare const StatusSelect: ReactFC<IStatusSelectProps>;
export declare const PaginationContext: import("react").Context<PaginationAction>;
export declare const usePagination: () => PaginationAction;
export declare const ArrayTablePagination: ReactFC<IArrayTablePaginationProps>;
export declare const WrapperComp: (props: React.HTMLAttributes<HTMLTableSectionElement>) => JSX.Element;
export declare const RowComp: ReactFC<React.HTMLAttributes<HTMLTableRowElement>>;
export declare const SortHandle: ReactFC<CommonProps>;
export declare const isOpenComponent: (schema: Schema) => boolean;
type CommonProps = ButtonProps & {
    index?: number;
};
export declare const Navigation: import("react").ForwardRefExoticComponent<Omit<CommonProps, "ref"> & import("react").RefAttributes<HTMLButtonElement>>;
export declare const Column: ReactFC<ColumnProps<any>>;
export declare const SidePanel: ReactFC<ColumnProps<any>>;
export declare const Addition: ArrayBaseMixins['Addition'];
export declare const isActionComponent: (schema: Schema) => boolean;
export declare const Action: ReactFC<ColumnProps<any>>;
export declare const useAction: (schema: Schema) => any;
export {};
