"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SideContent = exports.Addition = void 0;
var _dropdown = _interopRequireDefault(require("antd/lib/dropdown"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _collapse = _interopRequireDefault(require("antd/lib/collapse"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _badge = _interopRequireDefault(require("antd/lib/badge"));
var _card = _interopRequireDefault(require("antd/lib/card"));
var _empty = _interopRequireDefault(require("antd/lib/empty"));
var _react = require("@formily/react");
var _shared = require("@formily/shared");
var _classnames = _interopRequireDefault(require("classnames"));
var _react2 = _interopRequireWildcard(require("react"));
var _style = _interopRequireDefault(require("./style"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _antdV = require("@formily/antd-v5");
var _common = require("../common");
var _lodash = require("lodash");
var _icons = require("@ant-design/icons");
var _excluded = ["onClick"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var range = function range(count) {
  return Array.from({
    length: count
  }).map(function (_, i) {
    return i;
  });
};
var takeDefaultActiveKeys = function takeDefaultActiveKeys(dataSourceLength, defaultOpenPanelCount) {
  if (dataSourceLength < defaultOpenPanelCount) return range(dataSourceLength);
  return range(defaultOpenPanelCount);
};
var insertActiveKeys = function insertActiveKeys(activeKeys, index) {
  if (activeKeys.length <= index) return activeKeys.concat(index);
  return activeKeys.reduce(function (buf, key) {
    if (key < index) return buf.concat(key);
    if (key === index) return buf.concat([key, key + 1]);
    return buf.concat(key + 1);
  }, []);
};
var SideContent = exports.SideContent = (0, _react.observer)(function (props) {
  var _props$defaultOpenPan;
  var array = _antdV.ArrayBase.useArray();
  var schema = (0, _react.useFieldSchema)();
  var field = array.field;
  var prefixCls = (0, _builtins__.usePrefixCls)('side-content', props);
  var _useStyle = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var dataSource = Array.isArray(field.value) ? field.value.slice() : [];
  var _useState = (0, _react2.useState)(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan !== void 0 ? _props$defaultOpenPan : Infinity)),
    activeKeys = _useState[0],
    setActiveKeys = _useState[1];
  (0, _react2.useEffect)(function () {
    if (!field.modified && dataSource.length) {
      var _props$defaultOpenPan2;
      setActiveKeys(takeDefaultActiveKeys(dataSource.length, (_props$defaultOpenPan2 = props.defaultOpenPanelCount) !== null && _props$defaultOpenPan2 !== void 0 ? _props$defaultOpenPan2 : Infinity));
    }
  }, [dataSource.length, field]);
  if (!schema) throw new Error('can not found schema object');
  var renderEmpty = function renderEmpty() {
    if (dataSource.filter(function (item) {
      return (0, _lodash.get)(item, 'decorator-props.options.rules');
    }).length) return;
    return /*#__PURE__*/_react2["default"].createElement(_card["default"], {
      className: (0, _classnames["default"])(prefixCls + "-item", hashId, props.className)
    }, /*#__PURE__*/_react2["default"].createElement(_empty["default"], null));
  };
  var renderItems = function renderItems() {
    if (dataSource.filter(function (item) {
      return (0, _lodash.get)(item, 'decorator-props.options.rules');
    }).length === 0) {
      return null;
    }
    return /*#__PURE__*/_react2["default"].createElement(_collapse["default"], (0, _extends2["default"])({}, props, {
      activeKey: activeKeys,
      onChange: function onChange(keys) {
        setActiveKeys((0, _shared.toArr)(keys).map(Number));
      },
      className: (0, _classnames["default"])(prefixCls + "-item", hashId, props.className)
    }), dataSource.map(function (item, index) {
      if (!(0, _lodash.get)(item, 'decorator-props.options.rules')) return null;
      var items = Array.isArray(schema.items) ? schema.items[index] || schema.items[0] : schema.items;
      if (!items) return null;
      var header = function header() {
        var header = (0, _lodash.get)(item, 'decorator-props.title');
        var path = field.address.concat(index);
        var errors = field.form.queryFeedbacks({
          type: 'error',
          address: path + ".**"
        });
        return /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
          index: index,
          record: function record() {
            var _field$value;
            return (_field$value = field.value) === null || _field$value === void 0 ? void 0 : _field$value[index];
          }
        }, /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
          schema: items,
          name: index,
          filterProperties: function filterProperties(schema) {
            if (!(0, _common.isIndexComponent)(schema)) return false;
            return true;
          },
          onlyRenderProperties: true
        }), errors.length ? /*#__PURE__*/_react2["default"].createElement(_badge["default"], {
          size: "small",
          className: "errors-badge",
          count: errors.length
        }, header) : header);
      };
      var extra = /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
        index: index,
        record: item
      }, /*#__PURE__*/_react2["default"].createElement(Remove, null));
      var content = /*#__PURE__*/_react2["default"].createElement(_react.RecursionField, {
        schema: items,
        name: index,
        filterProperties: function filterProperties(schema) {
          if ((0, _common.isSidePanelComponent)(schema)) return true;
          return false;
        }
      });
      return /*#__PURE__*/_react2["default"].createElement(_collapse["default"].Panel, (0, _extends2["default"])({}, props, {
        forceRender: true,
        key: index,
        header: header(),
        extra: extra
      }), /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase.Item, {
        index: index,
        key: index,
        record: item
      }, content));
    }));
  };
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_card["default"], {
    title: "\u6821\u9A8C\u89C4\u5219"
  }, /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayBase, {
    onAdd: function onAdd(index) {
      setActiveKeys(insertActiveKeys(activeKeys, index));
    }
  }, renderEmpty(), renderItems(), /*#__PURE__*/_react2["default"].createElement(Addition, null))));
});
var Remove = /*#__PURE__*/(0, _react2.forwardRef)(function (props, ref) {
  var _array$field;
  var index = _antdV.ArrayBase.useIndex(props.index);
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var value = array.field.value || [];
  var prefixCls = (0, _builtins__.usePrefixCls)('formily-array-base');
  var _useStyle2 = (0, _style["default"])(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  if (!array) return null;
  if (((_array$field = array.field) === null || _array$field === void 0 ? void 0 : _array$field.pattern) !== 'editable') return null;
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends2["default"])({
    type: "ghost"
  }, props, {
    style: (0, _extends2["default"])({
      padding: '0 0 0 6px',
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: (0, _classnames["default"])(prefixCls + "-remove", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-remove-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _array$props, _array$props$onRemove;
      if (self !== null && self !== void 0 && self.disabled) return;
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
      (0, _lodash.set)(value, index + ".decorator-props.options.rules", undefined);
      (_array$props = array.props) === null || _array$props === void 0 ? void 0 : (_array$props$onRemove = _array$props.onRemove) === null || _array$props$onRemove === void 0 ? void 0 : _array$props$onRemove.call(_array$props, index);
    },
    icon: (0, _shared.isUndef)(props.icon) ? /*#__PURE__*/_react2["default"].createElement(_icons.DeleteOutlined, null) : props.icon
  }), props.title || self.title));
});
var Addition = exports.Addition = (0, _react.observer)(function (_ref) {
  var onClick = _ref.onClick,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var array = _antdV.ArrayBase.useArray();
  var value = array.field.value || [];
  var dataSource = value.filter(function (item) {
    return item && (0, _lodash.get)(item, 'decorator-props.title') && (0, _lodash.get)(item, 'decorator-props.fieldName');
  });
  var rules = value.filter(function (item) {
    return item && (0, _lodash.get)(item, 'decorator-props.options.rules');
  });
  var len = rules.length;
  var items = value.reduce(function (options, item, index) {
    var label = (0, _lodash.get)(item, 'decorator-props.title');
    if (item && (0, _lodash.get)(item, 'decorator-props.title') && (0, _lodash.get)(item, 'decorator-props.fieldName') && !rules.some(function (item) {
      return (0, _lodash.get)(item, 'decorator-props.title') === label;
    })) {
      options.push({
        label: label,
        key: index
      });
    }
    return options;
  }, []);
  if (dataSource.length === len) return null;
  var onDropdownClick = function onDropdownClick(menuInfo) {
    var key = menuInfo.key;
    (0, _lodash.set)(value, key + ".decorator-props.options.rules", []);
    if (onClick) {
      onClick(menuInfo);
    }
  };
  return /*#__PURE__*/_react2["default"].createElement(_dropdown["default"], {
    menu: {
      items: items,
      onClick: onDropdownClick
    },
    trigger: ['click']
  }, /*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends2["default"])({
    color: "primary",
    variant: "filled"
  }, props), "\u6DFB\u52A0\u9A8C\u8BC1\u5B57\u6BB5"));
});