"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.createPolyInput = createPolyInput;
var _button = _interopRequireDefault(require("antd/lib/button"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _style = require("./style");
var _excluded = ["className", "style", "value", "onChange", "exclude", "include"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var isValid = function isValid(val) {
  return val !== undefined && val !== null;
};
var getEventValue = function getEventValue(event) {
  if (event !== null && event !== void 0 && event.target) {
    if (isValid(event.target.value)) return event.target.value;
    if (isValid(event.target.checked)) return event.target.checked;
    return;
  }
  return event;
};
var createTypes = function createTypes(types, exclude, include) {
  return types.filter(function (_ref) {
    var type = _ref.type;
    if (Array.isArray(include) && include.length) {
      return include.includes(type);
    }
    if (Array.isArray(exclude) && exclude.length) {
      return !exclude.includes(type);
    }
    return true;
  });
};
function createPolyInput(polyTypes) {
  if (polyTypes === void 0) {
    polyTypes = [];
  }
  return /*#__PURE__*/(0, _react.memo)(function (_ref2) {
    var _types$;
    var className = _ref2.className,
      style = _ref2.style,
      value = _ref2.value,
      _onChange = _ref2.onChange,
      exclude = _ref2.exclude,
      include = _ref2.include,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
    var prefixCls = (0, _builtins__.usePrefixCls)('poly-input', props);
    var _useStyle = (0, _style.useStyle)(prefixCls),
      wrapSSR = _useStyle[0],
      hashId = _useStyle[1];
    var types = createTypes(polyTypes, exclude, include);
    var _useState = (0, _react.useState)((_types$ = types[0]) === null || _types$ === void 0 ? void 0 : _types$.type),
      current = _useState[0],
      setCurrent = _useState[1];
    var type = types === null || types === void 0 ? void 0 : types.find(function (_ref3) {
      var type = _ref3.type;
      return type === current;
    });
    var component = type === null || type === void 0 ? void 0 : type.component;
    var typesValue = (0, _react.useRef)({});
    (0, _react.useEffect)(function () {
      types === null || types === void 0 ? void 0 : types.forEach(function (_ref4) {
        var checker = _ref4.checker,
          type = _ref4.type;
        if (checker(value)) {
          setCurrent(type);
        }
      });
    }, [value]);
    var getNextType = function getNextType() {
      var currentIndex = types === null || types === void 0 ? void 0 : types.findIndex(function (_ref5) {
        var type = _ref5.type;
        return type === current;
      });
      var nextIndex = currentIndex + 1 > (types === null || types === void 0 ? void 0 : types.length) - 1 ? 0 : currentIndex + 1;
      return types[nextIndex];
    };
    var transformOnChangeValue = function transformOnChangeValue(value, type) {
      return type !== null && type !== void 0 && type.toChangeValue ? type === null || type === void 0 ? void 0 : type.toChangeValue(value) : value;
    };
    if (types.length === 2 && types.some(function (_ref6) {
      var type = _ref6.type;
      return type === 'EXPRESSION';
    })) {
      return wrapSSR(/*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(prefixCls, hashId, className),
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls + "-mixed"
      }, types.map(function (type) {
        return /*#__PURE__*/_react["default"].createElement(type === null || type === void 0 ? void 0 : type.component, (0, _extends2["default"])({}, props, {
          value: type !== null && type !== void 0 && type.toInputValue ? type === null || type === void 0 ? void 0 : type.toInputValue(value) : value,
          onChange: function onChange(event) {
            var value = getEventValue(event);
            typesValue.current[type === null || type === void 0 ? void 0 : type.type] = value;
            _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(value, type));
          }
        }));
      }))));
    }
    var controller = /*#__PURE__*/_react["default"].createElement(_button["default"], {
      className: prefixCls + "-controller",
      style: {
        width: !component ? '100%' : 'auto'
      },
      block: true,
      onClick: function onClick() {
        var nextType = getNextType();
        if (nextType === type) return;
        setCurrent(nextType === null || nextType === void 0 ? void 0 : nextType.type);
        _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(typesValue.current[nextType === null || nextType === void 0 ? void 0 : nextType.type], nextType));
      }
    }, type !== null && type !== void 0 && type.icon ? (0, _lowcodeUtils.createIcon)(type.icon, props) : (type === null || type === void 0 ? void 0 : type.title) || (type === null || type === void 0 ? void 0 : type.type));
    return wrapSSR(/*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])(prefixCls, hashId, className),
      style: style
    }, component && /*#__PURE__*/_react["default"].createElement("div", {
      className: prefixCls + "-content"
    }, /*#__PURE__*/_react["default"].createElement(component, (0, _extends2["default"])({}, props, {
      value: type !== null && type !== void 0 && type.toInputValue ? type === null || type === void 0 ? void 0 : type.toInputValue(value) : value,
      onChange: function onChange(event) {
        var value = getEventValue(event);
        typesValue.current[type === null || type === void 0 ? void 0 : type.type] = value;
        _onChange === null || _onChange === void 0 ? void 0 : _onChange(transformOnChangeValue(value, type));
      }
    }))), controller));
  });
}