"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.RenameNodeForm = void 0;
var _react = _interopRequireWildcard(require("react"));
var _core = require("@formily/core");
var _classnames = _interopRequireDefault(require("classnames"));
var _lodash = require("lodash");
var _antdV = require("@formily/antd-v5");
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var schema = {
  type: 'object',
  properties: {
    layout: {
      type: 'void',
      'x-component': 'FormCard',
      'x-component-props': {
        labelAlign: 'left',
        labelCol: 6,
        feedbackLayout: 'terse',
        colon: false
      },
      properties: {
        title: {
          type: 'string',
          title: '物料名称',
          'x-decorator': 'FormItem',
          'x-component': 'Input'
        }
      }
    }
  }
};
var RenameNodeForm = exports.RenameNodeForm = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var className = _ref.className,
    style = _ref.style,
    main = _ref.main;
  var form = (0, _react.useMemo)(function () {
    var values = {
      title: main.settings.titleLabel
    };
    return (0, _core.createForm)({
      values: values,
      effects: function effects() {
        (0, _core.onFormValuesChange)((0, _lodash.debounce)(function (form) {
          var values = form.values;
          main.settings.setTitleLabel(values.title);
        }, 100));
      }
    });
  }, [main]);
  var SchemaField = main.SchemaField;
  return /*#__PURE__*/_react["default"].createElement(_antdV.Form, {
    className: (0, _classnames["default"])('lc-node-rename-form', className),
    form: form,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(SchemaField, {
    schema: schema
  }));
});