"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.SelectInput = void 0;
var _autoComplete = _interopRequireDefault(require("antd/lib/auto-complete"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("@formily/react");
var _react2 = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _icons = require("@ant-design/icons");
var _antdV = require("@formily/antd-v5");
var _excluded = ["value", "options"];
var _SelectInput = function _SelectInput(_ref) {
  var value = _ref.value,
    options = _ref.options,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  var _useState = (0, _react2.useState)(options),
    _options = _useState[0],
    setOptions = _useState[1];
  var getPanelValue = function getPanelValue(searchText) {
    return !searchText ? [] : [{
      value: searchText,
      label: searchText
    }];
  };
  var filterOption = function filterOption(inputValue, option) {
    return ((option === null || option === void 0 ? void 0 : option.value) + '').toLowerCase().includes(inputValue.toLowerCase());
  };
  return /*#__PURE__*/React.createElement(_autoComplete["default"], (0, _extends2["default"])({
    options: _options,
    value: value,
    onSearch: function onSearch(text) {
      return setOptions(getPanelValue(text));
    },
    allowClear: true,
    filterOption: filterOption,
    style: {
      width: '100%'
    }
  }, props));
};

/**
 * 输入选择组合组件
 */
var SelectInput = exports.SelectInput = (0, _react.connect)(_SelectInput, (0, _react.mapProps)({
  dataSource: 'options',
  loading: true
}, function (props, field) {
  return (0, _extends2["default"])({}, props, {
    className: (0, _classnames["default"])(props.className, 'gant-formily-input-select'),
    optionFontSize: 12,
    suffixIcon: field !== null && field !== void 0 && field['loading'] || field !== null && field !== void 0 && field['validating'] ? /*#__PURE__*/React.createElement(_icons.LoadingOutlined, null) : props.suffixIcon
  });
}), (0, _react.mapReadPretty)(_antdV.PreviewText.Select));