"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ValidatorSetter = exports.ArrayRuleItems = void 0;
var _dropdown = _interopRequireDefault(require("antd/lib/dropdown"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _antdV = require("@formily/antd-v5");
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _jsonSchema = require("@formily/json-schema");
var _react = require("@formily/react");
var _react2 = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _style = require("./style");
var _shared = require("@formily/shared");
var _lodash = require("lodash");
var _icons = require("@ant-design/icons");
var _sideContent = require("../array-advance-table/side-content");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var validatorFormats = [{
  label: 'URL地址',
  value: 'url'
}, {
  label: '邮箱格式',
  value: 'email'
}, {
  label: '数字格式',
  value: 'number'
}, {
  label: '整数格式',
  value: 'integer'
}, {
  label: '小数格式',
  value: 'float'
}, {
  label: '身份证格式',
  value: 'idcard'
}, {
  label: '手机号格式',
  value: 'phone'
}, {
  label: '货币格式',
  value: 'money'
}, {
  label: '中文格式',
  value: 'zh'
}, {
  label: '日期格式',
  value: 'date'
}, {
  label: '邮编格式',
  value: 'zip'
}];
var validatorSchema = {
  type: 'array',
  items: {
    type: 'object',
    'x-component': 'FormLayout',
    'x-component-props': {
      feedbackLayout: 'terse',
      labelCol: 6,
      colon: false,
      labelAlign: 'left'
    },
    properties: {
      group: {
        type: 'void',
        'x-component': 'RuleGroup',
        properties: {
          layout: {
            type: 'void',
            'x-component': 'FormRow',
            properties: {
              col1: {
                type: 'void',
                'x-component': 'FormRow.Col',
                'x-component-props': {
                  flex: '25px',
                  style: {
                    display: 'flex',
                    alignItems: 'center'
                  }
                },
                properties: {
                  sort: {
                    type: 'void',
                    'x-decorator': 'FormItem',
                    'x-component': 'ArrayItems.SortHandle'
                  }
                }
              },
              col2: {
                type: 'void',
                'x-component': 'FormRow.Col',
                'x-component-props': {
                  flex: 'auto'
                },
                properties: {
                  __ruleType__: {
                    type: 'string',
                    'x-hidden': true
                  },
                  requiredGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() == "required") }}',
                    properties: {
                      required: {
                        type: 'string',
                        title: '必填',
                        'x-decorator': 'FormItem',
                        'x-component': 'Switch',
                        'x-hidden': true
                      },
                      message: {
                        type: 'string',
                        title: '必填',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  patternGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "pattern") }}',
                    properties: {
                      pattern: {
                        type: 'string',
                        title: '正则',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input',
                        'x-component-props': {
                          prefix: '/',
                          suffix: '/'
                        }
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  formatGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "format") }}',
                    properties: {
                      format: {
                        type: 'string',
                        title: '格式',
                        "enum": validatorFormats,
                        'x-decorator': 'FormItem',
                        'x-component': 'Select',
                        'x-component-props': {
                          allowClear: true
                        }
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  lenGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "len") }}',
                    properties: {
                      len: {
                        type: 'string',
                        title: '长度',
                        'x-decorator': 'FormItem',
                        'x-component': 'InputNumber'
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  minGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "min") }}',
                    properties: {
                      min: {
                        type: 'string',
                        title: '最小值',
                        'x-decorator': 'FormItem',
                        'x-component': 'InputNumber'
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  maxGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "max") }}',
                    properties: {
                      max: {
                        type: 'string',
                        title: '最大值',
                        'x-decorator': 'FormItem',
                        'x-component': 'InputNumber'
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  dateGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "date") }}',
                    properties: {
                      date: {
                        type: 'string',
                        title: '日期',
                        'x-decorator': 'FormItem',
                        'x-component': 'Select',
                        'x-component-props': {
                          allowClear: true
                        }
                      },
                      message: {
                        type: 'string',
                        title: '提示信息',
                        'x-decorator': 'FormItem',
                        'x-component': 'Input'
                      }
                    }
                  },
                  whitespaceGroup: {
                    type: 'void',
                    'x-hidden': '{{ !($self.query(".__ruleType__").value() === "whitespace") }}',
                    properties: {
                      whitespace: {
                        type: 'string',
                        title: '空格',
                        'x-decorator': 'FormItem',
                        'x-component': 'Switch'
                      },
                      message: {
                        type: 'string',
                        title: '提示信息'
                      }
                    }
                  }
                }
              },
              col3: {
                type: 'void',
                'x-component': 'FormRow.Col',
                'x-component-props': {
                  flex: '25px',
                  style: {
                    display: 'flex',
                    alignItems: 'center'
                  }
                },
                properties: {
                  remove: {
                    type: 'void',
                    'x-decorator': 'FormItem',
                    'x-component': 'ArrayItems.Remove'
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  properties: {
    addValidatorRules: {
      type: 'void',
      title: '添加验证项',
      'x-component': 'ArrayRuleItems.Addition'
    }
  }
};
var ValidatorSetter = exports.ValidatorSetter = (0, _react.observer)(function () {
  var schema = (0, _react.useFieldSchema)();
  var fieldSchema = (0, _react2.useMemo)(function () {
    return new _jsonSchema.Schema(validatorSchema, schema);
  }, []);
  return /*#__PURE__*/_react2["default"].createElement(_react.SchemaContext.Provider, {
    value: fieldSchema
  }, /*#__PURE__*/_react2["default"].createElement(ArrayRuleItems, null));
});
var ruleTypes = [{
  key: 'required',
  label: '必填'
}, {
  key: 'pattern',
  label: '正则'
}, {
  key: 'format',
  label: '格式'
}, {
  key: 'len',
  label: '长度'
}, {
  key: 'min',
  label: '最小值'
}, {
  key: 'max',
  label: '最大值'
}, {
  key: 'date',
  label: '日期'
}];
var RuleAddition = (0, _react.observer)(function (props) {
  // 需要限制只能添加一次的规则类型
  var uniqueRules = ['required', 'format', 'len', 'min', 'max', 'date'];
  var prefixCls = (0, _builtins__.usePrefixCls)('ant-formily-array-items');
  var _useStyle = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var value = array.field.value || [];
  // 获取已存在的规则类型
  var existingRules = value.map(function (item) {
    return item.__ruleType__;
  });
  var items = ruleTypes.filter(function (item) {
    // 过滤已存在的唯一性规则
    return !(uniqueRules.includes(item.key) && existingRules.includes(item.key));
  });
  var onClick = function onClick(_ref) {
    var key = _ref.key,
      domEvent = _ref.domEvent;
    var defaultValue = {
      __ruleType__: key
    };
    if (key === 'required') {
      defaultValue = (0, _extends2["default"])({}, defaultValue, {
        required: true,
        message: '${name}必填'
      });
    }
    if (props.method === 'unshift') {
      var _array$field, _array$field$unshift, _array$props, _array$props$onAdd;
      (_array$field = array.field) === null || _array$field === void 0 ? void 0 : (_array$field$unshift = _array$field.unshift) === null || _array$field$unshift === void 0 ? void 0 : _array$field$unshift.call(_array$field, defaultValue);
      (_array$props = array.props) === null || _array$props === void 0 ? void 0 : (_array$props$onAdd = _array$props.onAdd) === null || _array$props$onAdd === void 0 ? void 0 : _array$props$onAdd.call(_array$props, 0);
    } else {
      var _array$field2, _array$field2$push, _array$props2, _array$props2$onAdd, _array$field3, _array$field3$value;
      (_array$field2 = array.field) === null || _array$field2 === void 0 ? void 0 : (_array$field2$push = _array$field2.push) === null || _array$field2$push === void 0 ? void 0 : _array$field2$push.call(_array$field2, defaultValue);
      (_array$props2 = array.props) === null || _array$props2 === void 0 ? void 0 : (_array$props2$onAdd = _array$props2.onAdd) === null || _array$props2$onAdd === void 0 ? void 0 : _array$props2$onAdd.call(_array$props2, (array === null || array === void 0 ? void 0 : (_array$field3 = array.field) === null || _array$field3 === void 0 ? void 0 : (_array$field3$value = _array$field3.value) === null || _array$field3$value === void 0 ? void 0 : _array$field3$value.length) - 1);
    }
    if (props.onClick) {
      props.onClick(domEvent);
    }
  };
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement("div", {
    className: (0, _classnames["default"])(prefixCls + "-toobar", hashId, props.className)
  }, /*#__PURE__*/_react2["default"].createElement(_dropdown["default"], {
    menu: {
      items: items,
      onClick: onClick
    },
    trigger: ['click']
  }, /*#__PURE__*/_react2["default"].createElement(_button["default"], {
    color: "primary",
    variant: "filled"
  }, props.title || self.title)), /*#__PURE__*/_react2["default"].createElement(Remove, null)));
});
var InternalArrayRuleItems = (0, _react.observer)(function (props) {
  return /*#__PURE__*/_react2["default"].createElement(_antdV.ArrayItems, props);
});
var ArrayRuleItems = exports.ArrayRuleItems = Object.assign(InternalArrayRuleItems, {
  Addition: RuleAddition
});
var Remove = /*#__PURE__*/(0, _react2.forwardRef)(function (props, ref) {
  var _array$field4;
  var index = (0, _sideContent.useIndex)(props.index);
  var rootArray = (0, _react2.useContext)(_sideContent.SideBaseContext);
  var self = (0, _react.useField)();
  var array = _antdV.ArrayBase.useArray();
  var value = rootArray.field.value || [];
  var prefixCls = (0, _builtins__.usePrefixCls)('ant-formily-array-items');
  var _useStyle2 = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  if (!array) return null;
  if (((_array$field4 = array.field) === null || _array$field4 === void 0 ? void 0 : _array$field4.pattern) !== 'editable') return null;
  return wrapSSR(/*#__PURE__*/_react2["default"].createElement(_button["default"], (0, _extends2["default"])({
    type: "ghost"
  }, props, {
    style: (0, _extends2["default"])({
      padding: 8,
      width: 'auto',
      height: 'auto'
    }, props.style),
    disabled: self === null || self === void 0 ? void 0 : self.disabled,
    className: (0, _classnames["default"])(prefixCls + "-remove", hashId, self !== null && self !== void 0 && self.disabled ? prefixCls + "-remove-disabled" : '', props.className),
    ref: ref,
    onClick: function onClick(e) {
      var _rootArray$props, _rootArray$props$onRe;
      if (self !== null && self !== void 0 && self.disabled) return;
      e.stopPropagation();
      if (props.onClick) {
        props.onClick(e);
        if (e.defaultPrevented) return;
      }
      var path = array.field.path.slice(1).toString();
      (0, _lodash.set)(value, path, undefined);
      (_rootArray$props = rootArray.props) === null || _rootArray$props === void 0 ? void 0 : (_rootArray$props$onRe = _rootArray$props.onRemove) === null || _rootArray$props$onRe === void 0 ? void 0 : _rootArray$props$onRe.call(_rootArray$props, index);
    },
    icon: (0, _shared.isUndef)(props.icon) ? /*#__PURE__*/_react2["default"].createElement(_icons.DeleteOutlined, null) : props.icon
  }), props.title));
});