"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.ValueInput = void 0;
var _inputNumber = _interopRequireDefault(require("antd/lib/input-number"));
var _switch = _interopRequireDefault(require("antd/lib/switch"));
var _checkbox = _interopRequireDefault(require("antd/lib/checkbox"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _input = _interopRequireDefault(require("antd/lib/input"));
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _polyInput = require("../poly-input");
var _expressionSetter = require("../expression-setter");
var _excluded = ["className", "mode"];
var STARTTAG_REX = /<([-A-Za-z0-9_]+)((?:\s+[a-zA-Z_:][-a-zA-Z0-9_:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)>/;
var isNumber = function isNumber(value) {
  return typeof value === 'number';
};
var isBoolean = function isBoolean(value) {
  return typeof value === 'boolean';
};
var isExpression = function isExpression(value) {
  return typeof value === 'object' && value.type === 'JSExpression';
};
var isRichText = function isRichText(value) {
  return typeof value === 'string' && STARTTAG_REX.test(value);
};
var isNormalText = function isNormalText(value) {
  return typeof value === 'string' && !isExpression(value) && !isRichText(value);
};
var takeNumber = function takeNumber(value) {
  var num = String(value).replace(/[^\d\.]+/, '');
  if (num === '') return;
  return Number(num);
};
var ValueInput = exports.ValueInput = (0, _polyInput.createPolyInput)([{
  type: 'TEXT',
  icon: 'text',
  component: _input["default"],
  checker: isNormalText
}, {
  type: 'BOOLEAN',
  icon: 'boolean',
  component: function component(_ref) {
    var className = _ref.className,
      mode = _ref.mode,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
    if (mode === 'checkbox') {
      return /*#__PURE__*/_react["default"].createElement(_checkbox["default"], (0, _extends2["default"])({}, props, {
        className: (0, _classnames["default"])(className, 'value-input-switch')
      }));
    }
    return /*#__PURE__*/_react["default"].createElement(_switch["default"], (0, _extends2["default"])({}, props, {
      className: (0, _classnames["default"])(className, 'value-input-switch')
    }));
  },
  checker: isBoolean,
  toInputValue: function toInputValue(value) {
    return !!value;
  },
  toChangeValue: function toChangeValue(value) {
    return !!value;
  }
}, {
  type: 'NUMBER',
  icon: 'number',
  component: _inputNumber["default"],
  checker: isNumber,
  toInputValue: takeNumber,
  toChangeValue: takeNumber
}, {
  type: 'EXPRESSION',
  icon: 'expression',
  component: _expressionSetter.ExpressionSetter,
  // component: (props: any) => {
  //   return (
  //     <Popover
  //       rootClassName="monaco-input-popover"
  //       content={
  //         <div
  //           style={{
  //             width: 400,
  //             height: 200,
  //             marginLeft: -12,
  //             marginRight: -12,
  //             marginBottom: -4,
  //           }}
  //         >
  //           <MonacoInput {...props} language="javascript.expression" />
  //         </div>
  //       }
  //       trigger="click"
  //     >
  //       <div>fx</div>
  //     </Popover>
  //   );
  // },
  checker: isExpression
  // toInputValue: (value) => {
  //   if (!value || value === '{{}}') return;
  //   const matched = String(value).match(EXPRESSION_REX);
  //   return matched?.[1] || value || '';
  // },
  // toChangeValue: (value) => {
  //   if (!value || value === '{{}}') return;
  //   const matched = String(value).match(EXPRESSION_REX);
  //   return `{{${matched?.[1] || value || ''}}}`;
  // },
}]);