"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.StageBox = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var _stageChain = _interopRequireDefault(require("./stage-chain"));
var _stage = _interopRequireDefault(require("./stage"));
var _popup = _interopRequireWildcard(require("../popup"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var StageBox = exports.StageBox = (0, _lowcodeEditorCore.observer)(function (props) {
  function createDefaultChain() {
    var stateName = props.skeleton.createStage({
      content: props.children,
      isRoot: true
    });
    return new _stageChain["default"](props.skeleton.getStage(stateName));
  }
  var _useState = (0, _react.useState)(props.stageChain || createDefaultChain()),
    stageChain = _useState[0];
  var _useState2 = (0, _react.useState)({}),
    _ = _useState2[0],
    forceUpdate = _useState2[1];
  var shellRef = (0, _react.useRef)(null);
  var popupPipe = (0, _react.useRef)(new _popup.PopupPipe());
  (0, _react.useEffect)(function () {
    var unsubscribe = stageChain.onStageChange(function () {
      return forceUpdate({});
    });
    return function () {
      return unsubscribe();
    };
  }, [stageChain]);
  (0, _react.useEffect)(function () {
    if (!shellRef.current) {
      return;
    }
    var shell = shellRef.current;

    /**
     * 向上层递归寻找 target
     * @param node 节点
     * @returns 节点的 dataset.stageTarget 信息
     */
    var _getTarget = function getTarget(node) {
      if (!node || !shell.contains(node) || node.nodeName === 'A' && node.getAttribute('href')) {
        return null;
      }
      var target = node.dataset ? node.dataset.stageTarget : null;
      if (target) {
        return target;
      }
      return _getTarget(node.parentNode);
    };
    var clickHandler = function clickHandler(e) {
      var target = _getTarget(e.target);
      if (!target) {
        return;
      }
      if (target === 'stageback') {
        stageChain.stageBack();
      } else if (target === 'stageexit') {
        stageChain.stageBackToRoot();
      } else {
        stageChain.stagePush(props.skeleton.getStage(target));
      }
    };
    shell.addEventListener('click', clickHandler, false);
    return function () {
      shell.removeEventListener('click', clickHandler);
    };
  }, [props.skeleton, stageChain]);
  var currentStage = stageChain.getCurrentStage();
  var refer = currentStage === null || currentStage === void 0 ? void 0 : currentStage.getRefer();
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: shellRef,
    className: (0, _classnames["default"])('skeleton-stagebox', props.className)
  }, /*#__PURE__*/_react["default"].createElement(_popup["default"], {
    popupPipe: popupPipe.current
  }, refer && /*#__PURE__*/_react["default"].createElement(_stage["default"], {
    key: refer.stage.getId(),
    stage: refer.stage,
    direction: refer.direction
  }), /*#__PURE__*/_react["default"].createElement(_stage["default"], {
    key: currentStage.getId(),
    stage: currentStage,
    direction: refer === null || refer === void 0 ? void 0 : refer.direction,
    current: true
  })));
});