"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _arrow = require("../../icons/arrow");
var _exit = require("../../icons/exit");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var Stage = function Stage(_ref) {
  var stage = _ref.stage,
    _ref$current = _ref.current,
    current = _ref$current === void 0 ? false : _ref$current,
    direction = _ref.direction;
  var additionClassNameRef = (0, _react.useRef)(null);
  var shellRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var timer = null;
    if (additionClassNameRef.current && shellRef.current) {
      timer = window.setTimeout(function () {
        var elem = shellRef.current;
        if (elem) {
          current ? elem.classList.remove(additionClassNameRef.current) : elem.classList.add(additionClassNameRef.current);
          additionClassNameRef.current = null;
        }
      }, 15);
    }
    return function () {
      return window.clearTimeout(timer);
    };
  }, [current, direction]);
  var _ref2 = stage,
    title = _ref2.title;
  var newTitle = (0, _lowcodeUtils.isTitleConfig)(title) ? title.label : title;
  var content = stage === null || stage === void 0 ? void 0 : stage.getContent();
  if (current && direction) {
    additionClassNameRef.current = "skeleton-stagebox-stagein-" + direction;
  } else if (direction) {
    additionClassNameRef.current = "skeleton-stagebox-stageout-" + direction;
  }
  var className = (0, _classnames["default"])('skeleton-stagebox-stage', {
    'skeleton-stagebox-refer': !current
  }, additionClassNameRef.current);
  var stageBacker = (stage === null || stage === void 0 ? void 0 : stage.hasBack()) && /*#__PURE__*/_react["default"].createElement("div", {
    className: "skeleton-stagebox-stagebacker"
  }, /*#__PURE__*/_react["default"].createElement(_arrow.IconArrow, {
    className: "skeleton-stagebox-stage-arrow",
    size: "medium",
    "data-stage-target": "stageback"
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: "skeleton-stagebox-stage-title"
  }, newTitle), /*#__PURE__*/_react["default"].createElement(_exit.IconExit, {
    className: "skeleton-stagebox-stage-exit",
    size: "medium",
    "data-stage-target": "stageexit"
  }));
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: shellRef,
    className: className
  }, stageBacker, /*#__PURE__*/_react["default"].createElement("div", {
    className: "skeleton-stagebox-stage-content"
  }, content));
};
var _default = exports["default"] = Stage;