"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.DialogDockView = DialogDockView;
exports.DockView = DockView;
exports.WidgetView = exports.TitledPanelView = exports.TabsPanelView = exports.PanelView = exports.PanelDockView = exports.DraggableLineView = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var _utils = require("../../widget/utils");
var _skeleton = require("../../skeleton");
var _draggableLine = _interopRequireDefault(require("../draggable-line"));
var _panelOperationRow = _interopRequireDefault(require("./panel-operation-row"));
require("./index.less");
var _excluded = ["dock", "className", "onClick"];
function DockView(_ref) {
  var _classNames;
  var title = _ref.title,
    icon = _ref.icon,
    description = _ref.description,
    size = _ref.size,
    className = _ref.className,
    onClick = _ref.onClick;
  return /*#__PURE__*/React.createElement(_lowcodeEditorCore.Title, {
    title: (0, _utils.composeTitle)(title, icon, description),
    className: (0, _classnames["default"])('lc-dock', className, (_classNames = {}, _classNames["lc-dock-" + size] = size, _classNames)),
    onClick: onClick
  });
}
var PanelDockView = exports.PanelDockView = (0, _lowcodeEditorCore.observer)(function (_ref2) {
  var dock = _ref2.dock,
    className = _ref2.className,
    _onClick = _ref2.onClick,
    props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded);
  var _useState = (0, _react.useState)(dock.actived),
    lastActived = _useState[0],
    setLastActived = _useState[1];
  (0, _react.useEffect)(function () {
    if (dock.actived !== lastActived) {
      setLastActived(dock.actived);
      var event = dock.actived ? _skeleton.SkeletonEvents.PANEL_DOCK_ACTIVE : _skeleton.SkeletonEvents.PANEL_DOCK_UNACTIVE;
      dock.skeleton.postEvent(event, dock.name, dock);
    }
  }, [dock, dock.actived, lastActived]);
  return /*#__PURE__*/React.createElement(DockView, (0, _extends2["default"])({}, props, {
    className: (0, _classnames["default"])(className, {
      actived: dock.actived
    }),
    onClick: function onClick() {
      _onClick === null || _onClick === void 0 ? void 0 : _onClick();
      dock.togglePanel();
    }
  }));
});
function DialogDockView() {
  return null;
}
var DraggableLineView = exports.DraggableLineView = (0, _lowcodeEditorCore.observer)(function (_ref3) {
  var _panel$config$props2, _panel$config, _panel$parent;
  var panel = _ref3.panel;
  var shellRef = (0, _react.useRef)(null);
  var defaultWidthRef = (0, _react.useRef)();
  var getDefaultWidth = function getDefaultWidth() {
    var _panel$config$props, _shellRef$current;
    var configWidth = panel === null || panel === void 0 ? void 0 : (_panel$config$props = panel.config.props) === null || _panel$config$props === void 0 ? void 0 : _panel$config$props.width;
    if (configWidth) return configWidth;
    if (defaultWidthRef.current) return defaultWidthRef.current;
    var containerRef = (_shellRef$current = shellRef.current) === null || _shellRef$current === void 0 ? void 0 : _shellRef$current.getParent();
    if (containerRef) {
      defaultWidthRef.current = containerRef.offsetWidth;
      return defaultWidthRef.current;
    }
    return 300;
  };
  var handleDrag = function handleDrag(value) {
    var _shellRef$current2, _panel$skeleton$edito;
    var defaultWidth = getDefaultWidth();
    var width = defaultWidth + value;
    var containerRef = (_shellRef$current2 = shellRef.current) === null || _shellRef$current2 === void 0 ? void 0 : _shellRef$current2.getParent();
    containerRef && (containerRef.style.width = width + "px");
    (_panel$skeleton$edito = panel.skeleton.editor) === null || _panel$skeleton$edito === void 0 ? void 0 : _panel$skeleton$edito.eventBus.emit('dockpane.drag', width);
  };
  var handleDragChange = function handleDragChange(type) {
    var editor = panel.skeleton.editor;
    editor === null || editor === void 0 ? void 0 : editor.eventBus.emit('dockpane.dragchange', type);
    editor === null || editor === void 0 ? void 0 : editor.eventBus.emit('designer.builtinSimulator.disabledEvents', type === 'start');
  };
  var enableDrag = (_panel$config$props2 = panel.config.props) === null || _panel$config$props2 === void 0 ? void 0 : _panel$config$props2.enableDrag;
  var isRightArea = ((_panel$config = panel.config) === null || _panel$config === void 0 ? void 0 : _panel$config.area) === 'rightArea';
  if (isRightArea || !enableDrag || (panel === null || panel === void 0 ? void 0 : (_panel$parent = panel.parent) === null || _panel$parent === void 0 ? void 0 : _panel$parent.name) === 'leftFixedArea') {
    return null;
  }
  return /*#__PURE__*/React.createElement(_draggableLine["default"], {
    ref: shellRef,
    position: "right",
    className: "lc-engine-slate-draggable-line-right",
    onDrag: handleDrag,
    onDragStart: function onDragStart() {
      return handleDragChange('start');
    },
    onDragEnd: function onDragEnd() {
      return handleDragChange('end');
    },
    maxIncrement: 500,
    maxDecrement: 0
    // TODO: 优化
    // maxIncrement={dock.getMaxWidth() - this.cachedSize.width}
    // maxDecrement={this.cachedSize.width - dock.getWidth()}
  });
});
var TitledPanelView = exports.TitledPanelView = (0, _lowcodeEditorCore.observer)(function (_ref4) {
  var _panel$skeleton$edito2, _panel$config$props3;
  var panel = _ref4.panel,
    area = _ref4.area;
  var _useState2 = (0, _react.useState)(false),
    lastVisible = _useState2[0],
    setLastVisible = _useState2[1];
  (0, _react.useEffect)(function () {
    var currentVisible = panel.inited && panel.visible;
    if (currentVisible !== lastVisible) {
      setLastVisible(currentVisible);
      var event = currentVisible ? _skeleton.SkeletonEvents.PANEL_SHOW : _skeleton.SkeletonEvents.PANEL_HIDE;
      panel.skeleton.postEvent(event, panel.name, panel);
    }
  }, [lastVisible, panel, panel.inited, panel.visible]);
  if (!panel.inited) return null;
  var panelName = area ? area + "-" + panel.name : panel.name;
  (_panel$skeleton$edito2 = panel.skeleton.editor) === null || _panel$skeleton$edito2 === void 0 ? void 0 : _panel$skeleton$edito2.eventBus.emit('skeleton.panel.toggle', {
    name: panelName,
    status: panel.visible ? 'show' : 'hide'
  });
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('lc-titled-panel', {
      hidden: !panel.visible
    }),
    id: panelName,
    "data-keep-visible-while-dragging": (_panel$config$props3 = panel.config.props) === null || _panel$config$props3 === void 0 ? void 0 : _panel$config$props3.keepVisibleWhileDragging
  }, /*#__PURE__*/React.createElement(_panelOperationRow["default"], {
    panel: panel
  }), /*#__PURE__*/React.createElement(PanelTitle, {
    panel: panel
  }), /*#__PURE__*/React.createElement("div", {
    className: "lc-panel-body"
  }, panel.body), /*#__PURE__*/React.createElement(DraggableLineView, {
    panel: panel
  }));
});
var PanelView = exports.PanelView = (0, _lowcodeEditorCore.observer)(function (_ref5) {
  var _panel$skeleton$edito3, _panel$config$props4;
  var panel = _ref5.panel,
    area = _ref5.area,
    hideOperationRow = _ref5.hideOperationRow,
    hideDragLine = _ref5.hideDragLine;
  var _useState3 = (0, _react.useState)(false),
    lastVisible = _useState3[0],
    setLastVisible = _useState3[1];
  (0, _react.useEffect)(function () {
    var currentVisible = panel.inited && panel.visible;
    if (currentVisible !== lastVisible) {
      setLastVisible(currentVisible);
      var event = currentVisible ? _skeleton.SkeletonEvents.PANEL_SHOW : _skeleton.SkeletonEvents.PANEL_HIDE;
      panel.skeleton.postEvent(event, panel.name, panel);
    }
  }, [lastVisible, panel, panel.inited, panel.visible]);
  if (!panel.inited) return null;
  var panelName = area ? area + "-" + panel.name : panel.name;
  (_panel$skeleton$edito3 = panel.skeleton.editor) === null || _panel$skeleton$edito3 === void 0 ? void 0 : _panel$skeleton$edito3.eventBus.emit('skeleton.panel.toggle', {
    name: panelName,
    status: panel.visible ? 'show' : 'hide'
  });
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('lc-panel', {
      hidden: !panel.visible
    }),
    id: panelName,
    "data-keep-visible-while-dragging": (_panel$config$props4 = panel.config.props) === null || _panel$config$props4 === void 0 ? void 0 : _panel$config$props4.keepVisibleWhileDragging
  }, !hideOperationRow && /*#__PURE__*/React.createElement(_panelOperationRow["default"], {
    panel: panel
  }), panel.body, !hideDragLine && /*#__PURE__*/React.createElement(DraggableLineView, {
    panel: panel
  }));
});
var TabsPanelView = exports.TabsPanelView = (0, _lowcodeEditorCore.observer)(function (_ref6) {
  var container = _ref6.container,
    shouldHideSingleTab = _ref6.shouldHideSingleTab;
  var titles = [];
  var contents = [];
  if (shouldHideSingleTab && container.items.length === 1) {
    contents.push(/*#__PURE__*/React.createElement(PanelView, {
      key: container.items[0].id,
      panel: container.items[0],
      hideOperationRow: true,
      hideDragLine: true
    }));
  } else {
    container.items.forEach(function (item) {
      titles.push(/*#__PURE__*/React.createElement(PanelTitle, {
        key: item.id,
        panel: item,
        className: "lc-tab-title"
      }));
      contents.push(/*#__PURE__*/React.createElement(PanelView, {
        key: item.id,
        panel: item,
        hideOperationRow: true,
        hideDragLine: true
      }));
    });
  }
  if (!titles.length) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, contents);
  }
  var handleTabClick = function handleTabClick(e) {
    var shell = e.currentTarget;
    var t = e.target;
    var elt = shell.firstElementChild;
    while (elt) {
      if (elt.contains(t)) {
        break;
      }
      elt = elt.nextElementSibling;
    }
    if (elt) {
      container.active(elt.dataset.name);
    }
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "lc-tabs"
  }, /*#__PURE__*/React.createElement("div", {
    className: "lc-tabs-title",
    onClick: handleTabClick
  }, titles), /*#__PURE__*/React.createElement("div", {
    className: "lc-tabs-content"
  }, contents));
});
var PanelTitle = (0, _lowcodeEditorCore.observer)(function (_ref7) {
  var panel = _ref7.panel,
    className = _ref7.className;
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('lc-panel-title', className, {
      actived: panel.actived
    }),
    "data-name": panel.name
  }, /*#__PURE__*/React.createElement(_lowcodeEditorCore.Title, {
    title: panel.title || panel.name
  }), panel.help && /*#__PURE__*/React.createElement(_lowcodeEditorCore.HelpTip, {
    help: panel.help
  }));
});
var WidgetView = exports.WidgetView = (0, _lowcodeEditorCore.observer)(function (_ref8) {
  var widget = _ref8.widget;
  var _useState4 = (0, _react.useState)(widget.visible),
    lastVisible = _useState4[0],
    setLastVisible = _useState4[1];
  var _useState5 = (0, _react.useState)(widget.disabled),
    lastDisabled = _useState5[0],
    setLastDisabled = _useState5[1];
  (0, _react.useEffect)(function () {
    if (widget.visible !== lastVisible) {
      setLastVisible(widget.visible);
      var event = widget.visible ? _skeleton.SkeletonEvents.WIDGET_SHOW : _skeleton.SkeletonEvents.WIDGET_HIDE;
      widget.skeleton.postEvent(event, widget.name, widget);
    }
    if (widget.disabled !== lastDisabled) {
      setLastDisabled(widget.disabled);
      var _event = widget.disabled ? _skeleton.SkeletonEvents.WIDGET_DISABLE : _skeleton.SkeletonEvents.WIDGET_ENABLE;
      widget.skeleton.postEvent(_event, widget.name, widget);
    }
  }, [widget.visible, widget.disabled]);
  if (!widget.visible) return null;
  return widget.disabled ? /*#__PURE__*/React.createElement("div", {
    className: "lc-widget-disabled"
  }, widget.body) : widget.body;
});