"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var LeftArea = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var area = _ref.area,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? 'lc-left-area' : _ref$className;
  if (area.isEmpty()) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(className, {
      'lc-area-visible': area.visible
    })
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area
  }));
});
var _default = exports["default"] = LeftArea;
var Contents = (0, _lowcodeEditorCore.observer)(function (_ref2) {
  var area = _ref2.area;
  var top = [];
  var bottom = [];
  area.container.items.slice().sort(function (a, b) {
    var _a$config, _b$config;
    var index1 = ((_a$config = a.config) === null || _a$config === void 0 ? void 0 : _a$config.index) || 0;
    var index2 = ((_b$config = b.config) === null || _b$config === void 0 ? void 0 : _b$config.index) || 0;
    return index1 === index2 ? 0 : index1 > index2 ? 1 : -1;
  }).forEach(function (item) {
    var content = /*#__PURE__*/React.createElement("div", {
      key: "left-area-" + item.name
    }, item.content);
    item.align === 'bottom' ? bottom.push(content) : top.push(content);
  });
  return /*#__PURE__*/React.createElement(_react.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "lc-left-area-top"
  }, top), /*#__PURE__*/React.createElement("div", {
    className: "lc-left-area-bottom"
  }, bottom));
});