"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var LeftFloatPane = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var _area$skeleton2, _area$skeleton2$leftF, _area$current2, _area$current2$config;
  var area = _ref.area;
  var disposeRef = (0, _react.useRef)();
  var focusingRef = (0, _react.useRef)();
  var shellRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var triggerClose = function triggerClose(e) {
      var _e$originalEvent, _e$originalEvent$targ, _e$originalEvent2;
      if (!area.visible) return;
      if ((_e$originalEvent = e.originalEvent) !== null && _e$originalEvent !== void 0 && (_e$originalEvent$targ = _e$originalEvent.target) !== null && _e$originalEvent$targ !== void 0 && _e$originalEvent$targ.classList.contains('insertion')) return;
      var panelElem = (_e$originalEvent2 = e.originalEvent) === null || _e$originalEvent2 === void 0 ? void 0 : _e$originalEvent2.target.closest('div[data-keep-visible-while-dragging="true"]');
      if (panelElem) return;
      area.setVisible(false);
    };
    area.skeleton.editor.eventBus.on('designer.drag', triggerClose);
    var project = area.skeleton.editor.get('project');
    focusingRef.current = area.skeleton.focusTracker.create({
      range: function range(e) {
        var _shellRef$current, _document$querySelect, _document$querySelect2, _project$simulatorHos, _project$simulatorHos2, _document$querySelect3, _document$querySelect4, _document$querySelect5, _area$current;
        var target = e.target;
        if (!target) return false;
        if ((_shellRef$current = shellRef.current) !== null && _shellRef$current !== void 0 && _shellRef$current.contains(target)) return true;
        if ((_document$querySelect = document.querySelector('.lc-simulator-content-frame')) !== null && _document$querySelect !== void 0 && (_document$querySelect2 = _document$querySelect.contentWindow) !== null && _document$querySelect2 !== void 0 && _document$querySelect2.document.documentElement.contains(target)) {
          return false;
        }
        if (project !== null && project !== void 0 && (_project$simulatorHos = project.simulatorHost) !== null && _project$simulatorHos !== void 0 && (_project$simulatorHos2 = _project$simulatorHos.contentWindow) !== null && _project$simulatorHos2 !== void 0 && _project$simulatorHos2.document.documentElement.contains(target)) {
          return false;
        }
        if ((_document$querySelect3 = document.querySelector('.lc-right-area')) !== null && _document$querySelect3 !== void 0 && _document$querySelect3.contains(target)) return false;
        if (!((_document$querySelect4 = document.querySelector('.lc-workbench')) !== null && _document$querySelect4 !== void 0 && _document$querySelect4.contains(target))) return true;
        if ((_document$querySelect5 = document.querySelector('.lc-workbench-body')) !== null && _document$querySelect5 !== void 0 && _document$querySelect5.contains(target)) return true;
        var docks = (_area$current = area.current) === null || _area$current === void 0 ? void 0 : _area$current.getAssocDocks();
        return !!(docks !== null && docks !== void 0 && docks.some(function (dock) {
          var _dock$getDOMNode;
          return (_dock$getDOMNode = dock.getDOMNode()) === null || _dock$getDOMNode === void 0 ? void 0 : _dock$getDOMNode.contains(target);
        }));
      },
      onEsc: function onEsc() {
        return area.setVisible(false);
      },
      onBlur: function onBlur() {
        return area.setVisible(false);
      }
    });
    disposeRef.current = function () {
      area.skeleton.editor.removeListener('designer.drag', triggerClose);
    };
    return function () {
      var _disposeRef$current, _focusingRef$current;
      (_disposeRef$current = disposeRef.current) === null || _disposeRef$current === void 0 ? void 0 : _disposeRef$current.call(disposeRef);
      (_focusingRef$current = focusingRef.current) === null || _focusingRef$current === void 0 ? void 0 : _focusingRef$current.purge();
    };
  }, [area]);
  (0, _react.useEffect)(function () {
    if (area.visible) {
      var _focusingRef$current2, _area$skeleton, _area$skeleton$leftFi;
      (_focusingRef$current2 = focusingRef.current) === null || _focusingRef$current2 === void 0 ? void 0 : _focusingRef$current2.active();
      var fixedContainer = area === null || area === void 0 ? void 0 : (_area$skeleton = area.skeleton) === null || _area$skeleton === void 0 ? void 0 : (_area$skeleton$leftFi = _area$skeleton.leftFixedArea) === null || _area$skeleton$leftFi === void 0 ? void 0 : _area$skeleton$leftFi.container;
      var currentFixed = fixedContainer === null || fixedContainer === void 0 ? void 0 : fixedContainer.current;
      currentFixed && fixedContainer.unactive(currentFixed);
    } else {
      var _focusingRef$current3;
      (_focusingRef$current3 = focusingRef.current) === null || _focusingRef$current3 === void 0 ? void 0 : _focusingRef$current3.suspense();
    }
  }, [area === null || area === void 0 ? void 0 : (_area$skeleton2 = area.skeleton) === null || _area$skeleton2 === void 0 ? void 0 : (_area$skeleton2$leftF = _area$skeleton2.leftFixedArea) === null || _area$skeleton2$leftF === void 0 ? void 0 : _area$skeleton2$leftF.container, area.visible]);
  var width = (_area$current2 = area.current) === null || _area$current2 === void 0 ? void 0 : (_area$current2$config = _area$current2.config.props) === null || _area$current2$config === void 0 ? void 0 : _area$current2$config.width;
  var style = width ? {
    width: width
  } : undefined;
  return /*#__PURE__*/React.createElement("div", {
    ref: shellRef,
    className: (0, _classnames["default"])('lc-left-float-pane', {
      'lc-area-visible': area.visible
    }),
    style: style
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area
  }));
});
var _default = exports["default"] = LeftFloatPane;
var Contents = (0, _lowcodeEditorCore.observer)(function (_ref2) {
  var area = _ref2.area;
  return /*#__PURE__*/React.createElement(_react.Fragment, null, area.container.items.map(function (panel) {
    return panel.content;
  }));
});