"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var Toolbar = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var area = _ref.area;
  if (area.isEmpty()) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('lc-toolbar', {
      'lc-area-visible': area.visible
    })
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area
  }));
});
var _default = exports["default"] = Toolbar;
var Contents = (0, _lowcodeEditorCore.observer)(function (_ref2) {
  var area = _ref2.area;
  var left = [];
  var center = [];
  var right = [];
  area.container.items.forEach(function (item) {
    if (item.align === 'center') {
      center.push(item.content);
    } else if (item.align === 'right') {
      right.push(item.content);
    } else {
      left.push(item.content);
    }
  });
  return /*#__PURE__*/React.createElement(_react.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-left"
  }, left), /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-center"
  }, center), /*#__PURE__*/React.createElement("div", {
    className: "lc-toolbar-right"
  }, right));
});