"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var TopArea = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var area = _ref.area,
    itemClassName = _ref.itemClassName,
    className = _ref.className;
  if (area.isEmpty()) {
    return null;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])(className, 'lc-top-area engine-actionpane', {
      'lc-area-visible': area.visible
    })
  }, /*#__PURE__*/React.createElement(Contents, {
    area: area,
    itemClassName: itemClassName
  }));
});
var _default = exports["default"] = TopArea;
var Contents = (0, _lowcodeEditorCore.observer)(function (_ref2) {
  var area = _ref2.area,
    itemClassName = _ref2.itemClassName;
  var left = [];
  var center = [];
  var right = [];
  area.container.items.slice().sort(function (a, b) {
    var _a$config, _b$config;
    var index1 = ((_a$config = a.config) === null || _a$config === void 0 ? void 0 : _a$config.index) || 0;
    var index2 = ((_b$config = b.config) === null || _b$config === void 0 ? void 0 : _b$config.index) || 0;
    return index1 === index2 ? 0 : index1 > index2 ? 1 : -1;
  }).forEach(function (item) {
    var content = /*#__PURE__*/React.createElement("div", {
      className: itemClassName || '',
      key: "top-area-" + item.name
    }, item.content);
    if (item.align === 'center') {
      center.push(content);
    } else if (item.align === 'left') {
      left.push(content);
    } else {
      right.push(content);
    }
  });
  return /*#__PURE__*/React.createElement(_react.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "lc-top-area-left"
  }, left), /*#__PURE__*/React.createElement("div", {
    className: "lc-top-area-center"
  }, center), /*#__PURE__*/React.createElement("div", {
    className: "lc-top-area-right"
  }, right));
});