"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Workbench = void 0;
var _configProvider = _interopRequireDefault(require("antd/lib/config-provider"));
var _react = require("react");
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var _classnames = _interopRequireDefault(require("classnames"));
var _topArea = _interopRequireDefault(require("./top-area"));
var _leftArea = _interopRequireDefault(require("./left-area"));
var _leftFixedPane = _interopRequireDefault(require("./left-fixed-pane"));
var _leftFloatPane = _interopRequireDefault(require("./left-float-pane"));
var _toolbar = _interopRequireDefault(require("./toolbar"));
var _mainArea = _interopRequireDefault(require("./main-area"));
var _bottomArea = _interopRequireDefault(require("./bottom-area"));
var _rightArea = _interopRequireDefault(require("./right-area"));
require("./workbench.less");
var _context = require("../context");
var _zh_CN = _interopRequireDefault(require("antd/locale/zh_CN"));
var skeletonTheme = {
  token: {
    colorTextHeading: '#666',
    fontSize: 12 // 全局基础字号
  },
  components: {
    Card: {
      bodyPadding: 12,
      headerPadding: 12
    }
  }
};
var Workbench = exports.Workbench = (0, _lowcodeEditorCore.observer)(function (_ref) {
  var skeleton = _ref.skeleton,
    config = _ref.config,
    components = _ref.components,
    className = _ref.className,
    topAreaItemClassName = _ref.topAreaItemClassName;
  var _useState = (0, _react.useState)(400),
    width = _useState[0],
    setWidth = _useState[1];
  var _useState2 = (0, _react.useState)(false),
    startDrag = _useState2[0],
    setStartDrag = _useState2[1];
  (0, _react.useEffect)(function () {
    skeleton.buildFromConfig(config, components);
  }, []);
  var handleSplitterMouseDown = function handleSplitterMouseDown(e) {
    e.preventDefault();
    var startX = e.clientX;
    var startWidth = width;
    setStartDrag(true);
    var doDrag = function doDrag(moveEvent) {
      var deltaX = moveEvent.clientX - startX;
      var newWidth = startWidth - deltaX;
      setWidth(Math.max(400, Math.min(800, newWidth)));
    };
    var _stopDrag = function stopDrag() {
      setStartDrag(false);
      document.removeEventListener('mousemove', doDrag);
      document.removeEventListener('mouseup', _stopDrag);
    };
    document.addEventListener('mousemove', doDrag);
    document.addEventListener('mouseup', _stopDrag);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: (0, _classnames["default"])('lc-workbench', className)
  }, /*#__PURE__*/React.createElement(_configProvider["default"], {
    theme: skeletonTheme,
    locale: _zh_CN["default"]
  }, /*#__PURE__*/React.createElement(_context.SkeletonContext.Provider, {
    value: skeleton
  }, /*#__PURE__*/React.createElement("div", {
    className: "lc-workbench-body"
  }, /*#__PURE__*/React.createElement(_leftArea["default"], {
    area: skeleton.leftArea
  }), /*#__PURE__*/React.createElement(_leftFloatPane["default"], {
    area: skeleton.leftFloatArea
  }), /*#__PURE__*/React.createElement(_leftFixedPane["default"], {
    area: skeleton.leftFixedArea
  }), /*#__PURE__*/React.createElement("div", {
    className: "lc-workbench-body-right"
  }, /*#__PURE__*/React.createElement(_topArea["default"], {
    area: skeleton.topArea,
    itemClassName: topAreaItemClassName
  }), /*#__PURE__*/React.createElement("div", {
    className: "lc-workbench-splitter"
  }, /*#__PURE__*/React.createElement("div", {
    className: "lc-workbench-center left-area-splitter-panel"
  }, /*#__PURE__*/React.createElement(_toolbar["default"], {
    area: skeleton.toolbar
  }), /*#__PURE__*/React.createElement(_mainArea["default"], {
    area: skeleton.mainArea
  }), /*#__PURE__*/React.createElement(_bottomArea["default"], {
    area: skeleton.bottomArea
  })), /*#__PURE__*/React.createElement("div", {
    className: "splitter-bar",
    onMouseDown: handleSplitterMouseDown
  }, /*#__PURE__*/React.createElement("div", {
    className: "splitter-bar-dragger"
  })), /*#__PURE__*/React.createElement("div", {
    className: "right-area-splitter-panel",
    style: {
      width: width
    }
  }, /*#__PURE__*/React.createElement(_rightArea["default"], {
    area: skeleton.rightArea
  })), startDrag && /*#__PURE__*/React.createElement("div", {
    "aria-hidden": true,
    className: "splitter-mask"
  })))), /*#__PURE__*/React.createElement(_lowcodeEditorCore.TipContainer, null))));
});