"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.VariableBind = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _space = _interopRequireDefault(require("antd/lib/space"));
var _button = _interopRequireDefault(require("antd/lib/button"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _message2 = _interopRequireDefault(require("antd/lib/message"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _builtins__ = require("@formily/antd-v5/lib/__builtins__");
var _style = require("./style");
var _core = require("@formily/core");
var _expressionSetter = require("./expression-setter");
var _utils = require("./utils");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var VariableBind = exports.VariableBind = function VariableBind(_props) {
  var commonUI = _props.commonUI,
    className = _props.className,
    engineConfig = _props.engineConfig,
    event = _props.event;
  var Modal = commonUI.Modal;
  var _message$useMessage = _message2["default"].useMessage(),
    messageApi = _message$useMessage[0],
    contextHolder = _message$useMessage[1];
  var _useState = (0, _react.useState)(),
    selected = _useState[0],
    setSelected = _useState[1];
  var _useState2 = (0, _react.useState)(),
    field = _useState2[0],
    setField = _useState2[1];
  var prefixCls = (0, _builtins__.usePrefixCls)('variable-bind');
  var _useStyle = (0, _style.useStyle)(prefixCls),
    wrapSSR = _useStyle[0],
    hashId = _useStyle[1];
  var _useState3 = (0, _react.useState)({}),
    props = _useState3[0],
    setProps = _useState3[1];
  var _useState4 = (0, _react.useState)({}),
    values = _useState4[0],
    onChange = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    isModalOpen = _useState5[0],
    setIsModalOpen = _useState5[1];
  var _useState6 = (0, _react.useState)(null),
    form = _useState6[0],
    setForm = _useState6[1];
  var showModal = function showModal() {
    setIsModalOpen(true);
  };
  (0, _react.useEffect)(function () {
    return event.on('common:variableBind.open', function (props, field, selected) {
      setProps(props);
      setField(field);
      setSelected(selected);
      var values = {
        type: 'JSExpression',
        isFixed: false,
        variableName: '',
        mock: props.value,
        statementId: ''
      };
      console.log('-VariableBind----props', props);
      if ((0, _lowcodeUtils.isJSExpression)(props.value)) {
        if (props.value.isFixed) {
          var statement = selected.getStatementById(props.value.statementId);
          console.log('-VariableBind----props.statementId', props.value.statementId);
          values = (0, _extends2["default"])({}, props.value, {
            value: (0, _utils.getAssignmentCode)(statement.value)
          });
        } else {
          values = props.value;
        }
        onChange(values);
      } else {
        onChange(values);
      }
      setForm((0, _core.createForm)({
        initialValues: values
      }));
      showModal();
    });
  }, [event]);
  var getMockOrValue = function getMockOrValue() {
    var v = props.value;
    if ((0, _lowcodeUtils.isJSExpression)(v)) {
      return v.mock;
    }
    return v;
  };
  var disabled = !(0, _lowcodeUtils.isJSExpression)(props.value);
  var handleCancel = function handleCancel() {
    setIsModalOpen(false);
  };
  var systemVariableOptionsTree = engineConfig.get('systemVariableOptionsTree', []);
  var handleOk = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var values, finalValue, statementId, statement, isCircular, isDefined, identifiers, prop;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return form.validate();
          case 2:
            values = form.values;
            console.log('----values', values);
            statementId = selected.id + "_" + field.path.toString();
            statement = {
              type: 'JsVarDeclaration',
              id: statementId,
              name: values.variableName,
              value: "const " + values.variableName + " = " + values.value + ";",
              source: "const " + values.variableName + " = " + values.value + ";",
              references: [statementId]
            }; // 定义变量 是否循环引用
            isCircular = false;
            isDefined = false;
            identifiers = (0, _utils.extractReferencedIdentifiers)(values.value);
            identifiers.forEach(function (identifier) {
              if (identifier === values.variableName) {
                messageApi.warning("\u53D8\u91CF" + identifier + "\u4E0D\u80FD\u5F15\u7528\u81EA\u8EAB");
                isCircular = true;
                return;
              }
              var isSystemVariable = (0, _utils.hasInVariables)(systemVariableOptionsTree, identifier);
              if (!selected.hasStatement({
                name: identifier
              }) && !isSystemVariable) {
                messageApi.warning("\u53D8\u91CF" + identifier + "\u4E0D\u5B58\u5728");
                isDefined = true;
                return;
              }
              // 如果使用的是系统变量，不添加引用
              if (!isSystemVariable) {
                selected.addStatementReference(identifier, statementId);
              }
            });
            if (!(isCircular || isDefined)) {
              _context.next = 12;
              break;
            }
            return _context.abrupt("return");
          case 12:
            if (!values.isFixed) {
              _context.next = 21;
              break;
            }
            if (!selected.hasStatement(statement)) {
              _context.next = 16;
              break;
            }
            messageApi.warning("\u5DF2\u5B58\u5728\u540D\u5B57\u4E3A" + values.variableName + "\u7684\u53D8\u91CF");
            return _context.abrupt("return");
          case 16:
            prop = selected.addStatements(statement);
            console.log('作为页面变量', statement, selected, prop);
            finalValue = (0, _extends2["default"])({}, values, {
              type: 'JSExpression',
              value: values.variableName,
              mock: getMockOrValue(),
              statementId: statementId
            });
            _context.next = 23;
            break;
          case 21:
            selected.removeStatements(statement);
            finalValue = (0, _extends2["default"])({}, values, {
              type: 'JSExpression',
              mock: getMockOrValue()
            });
          case 23:
            Promise.resolve().then(function () {
              var _props$onChange;
              (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props, finalValue);
            });
            handleCancel();
          case 25:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function handleOk() {
      return _ref.apply(this, arguments);
    };
  }();
  var removeBind = function removeBind() {
    if (!disabled) {
      var statementId = selected.id + "_" + field.path.toString();
      var statement = {
        type: 'JsVarDeclaration',
        name: values.variableName,
        value: "const " + values.variableName + " = " + values.value + ";",
        source: "const " + values.variableName + " = " + values.value + ";",
        id: statementId,
        references: [statementId]
      };
      selected.removeStatements(statement);
      props.onChange(getMockOrValue());
      handleCancel();
    }
  };
  var footer = /*#__PURE__*/_react["default"].createElement("div", {
    className: prefixCls + "-footer"
  }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    color: "danger",
    variant: "outlined",
    onClick: removeBind,
    disabled: disabled
  }, "\u5220\u9664\u903B\u8F91"), /*#__PURE__*/_react["default"].createElement(_space["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    onClick: handleCancel
  }, "\u53D6\u6D88"), /*#__PURE__*/_react["default"].createElement(_button["default"], {
    type: "primary",
    onClick: handleOk
  }, "\u786E\u5B9A")));
  return wrapSSR(/*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, contextHolder, /*#__PURE__*/_react["default"].createElement(Modal, {
    className: (0, _classnames["default"])(prefixCls, hashId, className),
    title: "\u903B\u8F91\u7F16\u8F91\u5668",
    open: isModalOpen,
    onCancel: handleCancel,
    destroyOnClose: true,
    onOk: handleOk,
    width: 900,
    footer: footer
  }, /*#__PURE__*/_react["default"].createElement(_expressionSetter.ExpressionSetter, {
    selected: selected,
    config: engineConfig,
    form: form
  }))));
};