/**
 * 从 JS 表达式中提取被引用的变量标识符（Identifier）
 * @param {string} code JS 表达式，如 `test === 't' && test2 === 'b'`
 * @returns {string[]} 被引用的变量名数组
 */
export declare function extractReferencedIdentifiers(code: string): any[];
/**
 * 提取变量赋值语句中 `=` 号右边的表达式字符串
 * @param {string} code - 代码字符串，如 `const test = currentUser === 'admin';`
 * @returns {string | null} - 返回右侧表达式字符串（如 `currentUser === 'admin'`），如果无效则为 null
 */
export declare function getAssignmentCode(code: string): any;
export declare function hasInVariables(variables: any[], identifier: string): boolean;
